#!/bin/sh
#
# This script helps to support allowing the Locomotive rpm to be relocated 
# when installed.  This script changes the proper Locomotive config file
# lines so that the Locomotive is aware of its actual location.
#
# Author: Jason Brittain <brittainj@diamtech.com>
#
#######################################################################
#
# This script takes one argument: the prefix of the package.
# The prefix is usually "/usr/local", but if the user relocates the
# package, the prefix will be different, and the config files must use
# the new prefix.
#

# If the prefix isn't "/usr/local" then we need to change the config files.
if [ ! "$1" = "/usr/local" ] ; then
  echo $1 > /tmp/prefix
  sed -e 's/\//\\\//g' /tmp/prefix > /tmp/prefix2
  rm /tmp/prefix
  sed -e 's/\/usr\/local/'`cat /tmp/prefix2`'/' \
    $1/locomotive/config/loco.conf > /tmp/loco.conf
  sed -e 's/\/usr\/local/'`cat /tmp/prefix2`'/' \
    $1/locomotive/config/httpdtest.conf > /tmp/httpdtest.conf
  cp -f /tmp/loco.conf $1/locomotive/config/
  cp -f /tmp/httpdtest.conf $1/locomotive/config
  rm -f /tmp/prefix2
  rm -f /tmp/loco.conf
  rm -f /tmp/httpdtest.conf
fi


