-- The contents of this file are subject to the Locomotive Public License 
-- (LPL), a derivative of the Mozilla Public License, version 1.0. You 
-- may not use this file except in compliance with the License; You may 
-- obtain a copy of the License at http://www.locomotive.org/license/.
-- 
-- Software distributed under the License is distributed on an "AS IS" basis, 
-- WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License 
-- for the specific language governing rights and limitations under the License. 
--
-- The initial developers of this code under the LPL is Leverage Information 
-- Systems.  Portions created by Leverage are Copyright (C) 1998 Leverage 
-- Information Systems.  All Rights reserved.

--      Primary Schema for Locomotive User/Session for use with
--      Locomotive Application Server for Cloudscape 1.2
--      Copyright 1998 Leverage.        All rights reserved.


-- This script is meant to be run using the java class COM.cloudscape.tools.ij,
-- which is Cloudscape's interactive database query and scripting tool.
-- First, create a separate database to put the Locomotive tables in.

connect 'jdbc:cloudscape:loco_dev;create=true';

connect 'jdbc:cloudscape:loco_dev';


-- Now, we have to add the tables used for holding our sequences.

create table loco_bstamp_sq (
	id LONGINT PRIMARY KEY
);

insert into loco_bstamp_sq values (100000);


create table loco_session_sq (
	id LONGINT PRIMARY KEY
);

insert into loco_session_sq values (1);

create table loco_user_sq (
	id INT PRIMARY KEY
);

insert into loco_user_sq values (10000);


-- now we can add the user and session tables

create table loco_sessions (
	sid LONGINT PRIMARY KEY,
	srid INT,
	userid INT,
	added TIMESTAMP,
	active TIMESTAMP,
	expire TIMESTAMP
) PROPERTIES cloudscape.storage.pageSize=8192;


create table loco_users (
	userid INT PRIMARY KEY,
	username varchar (32) NOT NULL UNIQUE,
	password varchar (32),
	loco_flags INT,
	added TIMESTAMP,
	modified TIMESTAMP,
	last_login TIMESTAMP
) PROPERTIES cloudscape.storage.pageSize=8192;	


insert into loco_users values (1, 'admin', 'changeme', 7, CURRENT_TIMESTAMP,
        CURRENT_TIMESTAMP, CURRENT_TIMESTAMP);

--drop table loco_session_objects;
 
create table loco_session_objects (
        sid LONGINT PRIMARY KEY ,
        objects SERIALIZE(java.util.Hashtable)
        ) PROPERTIES cloudscape.storage.pageSize=8192;


connect 'jdbc:cloudscape:;shutdown=true';

exit;
