-- The contents of this file are subject to the Locomotive Public License 
-- (LPL), a derivative of the Mozilla Public License, version 1.0. You 
-- may not use this file except in compliance with the License; You may 
-- obtain a copy of the License at http://www.locomotive.org/license/.
-- 
-- Software distributed under the License is distributed on an "AS IS" basis, 
-- WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License 
-- for the specific language governing rights and limitations under the License. 
--
-- The initial developers of this code under the LPL is Leverage Information 
-- Systems.  Portions created by Leverage are Copyright (C) 1998 Leverage 
-- Information Systems.  All Rights reserved.

--
--      Primary Schema for the Discussion demo for use with
--      Locomotive for Informix 
--

drop table community;
create table community (
	communityid SERIAL PRIMARY KEY,
	communityname varchar(255),
	communitydesc TEXT,
	communitystatus CHAR(4)
);

drop table communitytopic;
create table communitytopic (
	topicid SERIAL PRIMARY KEY,
	communityid INTEGER REFERENCES community (communityid) ON DELETE CASCADE,
	topicname VARCHAR(255),
	topicstatus CHAR(4)
);

drop table communitypost;
create table communitypost (
	postid SERIAL PRIMARY KEY,
	topicid INTEGER REFERENCES communitytopic (topicid) ON DELETE CASCADE,
	posttitle VARCHAR(255), 
	postbody TEXT,
	postauthorfn VARCHAR(100),
	postauthorln VARCHAR (100),
	postemail VARCHAR(100),
	postdate DATETIME YEAR to SECOND,
	poststatus char(4)
);

