-- The contents of this file are subject to the Locomotive Public License 
-- (LPL), a derivative of the Mozilla Public License, version 1.0. You 
-- may not use this file except in compliance with the License; You may 
-- obtain a copy of the License at http://www.locomotive.org/license/.
-- 
-- Software distributed under the License is distributed on an "AS IS" basis, 
-- WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License 
-- for the specific language governing rights and limitations under the License. 
--
-- The initial developers of this code under the LPL is Leverage Information 
-- Systems.  Portions created by Leverage are Copyright (C) 1998 Leverage 
-- Information Systems.  All Rights reserved.

--
--      Primary Schema for the Graffiti Wall demo for use with
--      Locomotive for Informix 
--

drop table loco_graffiti_tags;
create table loco_graffiti_tags (
   tag_id	integer			PRIMARY KEY,
   tag_author 	varchar(20),
   tag_text  	varchar(255),
   tag_ins_time 	datetime year to second 
   );

-- prepopulate

insert into loco_graffiti_tags values (1, 'anon', 
   'This is an example tag', CURRENT);
insert into loco_graffiti_tags values (2, 'anon', 
   'This is an example tag', CURRENT);
insert into loco_graffiti_tags values (3, 'anon', 
   'This is an example tag', CURRENT);
insert into loco_graffiti_tags values (4, 'anon', 
   'This is an example tag', CURRENT);
insert into loco_graffiti_tags values (5, 'anon', 
   'This is an example tag', CURRENT);
insert into loco_graffiti_tags values (6, 'anon', 
   'This is an example tag', CURRENT);
insert into loco_graffiti_tags values (7, 'anon', 
   'This is an example tag', CURRENT);
insert into loco_graffiti_tags values (8, 'anon', 
   'This is an example tag', CURRENT);
insert into loco_graffiti_tags values (9, 'anon', 
   'This is an example tag', CURRENT);
insert into loco_graffiti_tags values (10, 'anon', 
   'This is an example tag', CURRENT);


drop procedure loco_ow_graf_tag;
create procedure loco_ow_graf_tag(author VARCHAR (32, 0), 
		text VARCHAR(255))

	-- this procedure will delete the tag with the lowest id, 
	-- and insert a new tag with the author and name supplied

	define min_id_var integer;
	define esql integer;  -- this will hold the exception 
	
	ON EXCEPTION set esql  -- roll back if we run into trouble
		ROLLBACK WORK;
		RAISE EXCEPTION esql;
	END EXCEPTION

	BEGIN WORK;  -- start the transaction

	let min_id_var = (select min(tag_id) from loco_graffiti_tags);
	DELETE FROM loco_graffiti_tags where tag_id = min_id_var;
	insert into loco_graffiti_tags 
		(tag_id, tag_author, tag_text, tag_ins_time)
		values (0, author, text, CURRENT);
	
	COMMIT WORK;
end procedure;
	
