/*
-- The contents of this file are subject to the Locomotive Public License
-- (LPL), a derivative of the Mozilla Public License, version 1.0. You
-- may not use this file except in compliance with the License; You may
-- obtain a copy of the License at http://www.locomotive.org/license/.
--
-- Software distributed under the License is distributed on an "AS IS" basis,
-- WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
-- for the specific language governing rights and limitations under the
-- License.
--
-- The initial developers of this code under the LPL is Leverage Information
-- Systems.  Portions created by Leverage are Copyright (C) 1998 Leverage
-- Information Systems. All Rights reserved.
-- additions by Sundayta Ltd



-- NB NB NB

Note the two column name changes due to reserved words in Interbase
loco_sessions_active_date instead of loco_sessions.active
user.password_value instead of user.password

UGH UGH UGH
*/

drop table loco_session_objects;
drop table loco_sessions;
drop table loco_users;
DROP TABLE loco_ids;

commit;

create table loco_sessions (
  sid numeric (10) NOT NULL ,
  srid numeric (10) NOT NULL ,
  userid numeric (10),
  added date,
  active_date date,
  expire date,
  constraint PK_loco_sessions primary key (sid)
);

create table loco_users  (
  userid numeric(10) NOT NULL ,
  username varchar (32) NOT NULL UNIQUE,
  password_value varchar (32) NOT NULL ,
  loco_flags numeric(10) NOT NULL ,
  added date NOT NULL ,
  modified date,
  last_login date,
  constraint PK_loco_users primary key (userid)
);

commit;

insert into loco_users values (1, 'admin', 'changeme', 7, 'TODAY', 'TODAY', 'TODAY');
insert into loco_users values (0, 'anonymous', 'Anonymous', 7, 'TODAY', 'TODAY', 'TODAY');

create table loco_session_objects (
  sid numeric (10) NOT NULL,
  objects blob sub_type 0,
  constraint PK_loco_session_objects primary key (sid)
);

CREATE TABLE loco_ids (
  id_type        integer  NOT NULL PRIMARY KEY,
  next_available numeric(10)  NOT NULL
);

commit;

grant all on loco_sessions to loco;
grant all on loco_users to loco;
grant all on loco_session_objects to loco;
grant all on loco_ids to loco;
