# The contents of this file are subject to the Locomotive Public License 
# (LPL), a derivative of the Mozilla Public License, version 1.0. You 
# may not use this file except in compliance with the License; You may 
# obtain a copy of the License at http://www.locomotive.org/license/.
# 
# Software distributed under the License is distributed on an "AS IS" basis, 
# WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License 
# for the specific language governing rights and limitations under the License. 
#
# The initial developers of this code under the LPL is Leverage Information 
# Systems.  Portions created by Leverage are Copyright (C) 1998 Leverage 
# Information Systems.  All Rights reserved.


#	Primary Schema for Bug Tracker demo for use with
#	Leverage Locomotive for MySQL 3.22.23
#	Copyright (c) 1998 Leverage.	All rights reserved.


drop table if exists btrack_bugs;
create table btrack_bugs (
			id BIGINT UNSIGNED AUTO_INCREMENT PRIMARY KEY,
			project_id MEDIUMINT UNSIGNED NOT NULL,
			version varchar(64) , 
			status varchar(128) NOT NULL,
			severity varchar(64),
			priority TINYINT UNSIGNED NOT NULL,
			summary varchar(128) NOT NULL,
			resolution varchar(64),
			assigned_to_user INT,
			creator_user_id INT NOT NULL,
			created DATETIME NOT NULL,
			modified DATETIME NOT NULL
			);

drop table if exists btrack_bug_text;
create table btrack_bug_text (
			bug_id BIGINT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY,
			text TEXT,
			creator_user_id INT NOT NULL,
			created DATETIME NOT NULL
			);

drop table if exists btrack_projects;
create table btrack_projects (
	     		id SMALLINT UNSIGNED AUTO_INCREMENT  PRIMARY KEY,
			short_title VARCHAR(64),
			long_title varchar(255),
			text TEXT,
			status varchar(128),
			creator_userid INT NOT NULL,
			created DATETIME NOT NULL,
			modified DATETIME NOT NULL,
			owner_userid INT UNSIGNED,
			mail_news_list varchar(255)
			);

#create index btrack_bug_text_ix on btrack_bug_text (bug_id);

drop table if exists btrack_project_history;
create table btrack_project_history (
			id BIGINT UNSIGNED PRIMARY KEY,
			modified_by INT NOT NULL,
			new_info TEXT NOT NULL,
			date_modified DATETIME NOT NULL
			);

drop table if exists btrack_bug_history;
create table btrack_bug_history (
			id BIGINT PRIMARY KEY,
			modified_by INT NOT NULL,
			new_info TEXT NOT NULL,
			date_modified DATETIME NOT NULL
			); 


