# The contents of this file are subject to the Locomotive Public License 
# (LPL), a derivative of the Mozilla Public License, version 1.0. You 
# may not use this file except in compliance with the License; You may 
# obtain a copy of the License at http://www.locomotive.org/license/.
# 
# Software distributed under the License is distributed on an "AS IS" basis, 
# WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License 
# for the specific language governing rights and limitations under the License. 
#
# The initial developers of this code under the LPL is Leverage Information 
# Systems.  Portions created by Leverage are Copyright (C) 1998 Leverage 
# Information Systems.  All Rights reserved.

#
#      Primary Schema for Locomotive User/Session for use with
#      Locomotive Application Server for MySQL 3.22
#      Copyright 1998 Leverage.        All rights reserved.
#


#
# first, create a separate database and create a loco user to go with it.
# To do this, sign on as the root user to the mysql database- 
# with the shell command 'mysql -uroot -p(password) mysql'.
# Then, issue the following commands.  If you're re-installing the
# tables, you'll have to uncomment the lines which drop and delete 
# the loco database and user.
#

# drop database dev;

create database dev;

# delete from user where user = 'loco';

insert into user (host, user, password) values 
	('localhost', 'loco', password('loco_pw'));

# This next command is for connecting from beyond the local machine 
insert into user (host, user, password) values 
        ('%', 'loco', password('loco_pw'));

# delete from db where user = 'loco';

insert into db (host, db, user, select_priv, insert_priv, 
	update_priv,delete_priv, create_priv, drop_priv) values
 	('%', 'dev', 'loco', 'Y', 'Y', 'Y', 'Y', 'Y', 'Y');


# now, sign out and reload the privilege changes using the shell command:
#     mysqladmin -uroot -p(password) reload
#
# to install the locomotive tables, sign on as the loco user using the
# shell command 'mysql -uloco -ploco_pw dev' and run the scripts in
# 'loco_user.sql' and 'loco_session.sql'.




