
# The contents of this file are subject to the Locomotive Public License 
# (LPL), a derivative of the Mozilla Public License, version 1.0. You 
# may not use this file except in compliance with the License; You may 
# obtain a copy of the License at http://www.locomotive.org/license/.
# 
# Software distributed under the License is distributed on an "AS IS" basis, 
# WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License 
# for the specific language governing rights and limitations under the License. 
#
# The initial developers of this code under the LPL is Leverage Information 
# Systems.  Portions created by Leverage are Copyright (C) 1998 Leverage 
# Information Systems.  All Rights reserved.

#
#      Primary Schema for the Discussion demo for use with
#      NOTE: You must install the loco_permissions sql tables first
#      Leverage Locomotive for MySQL 
#      Copyright (c) 1998 Locomotive Application Server Group. 
#      All rights reserved.
#

#drop table if exists community;
create table community (
	communityid INTEGER AUTO_INCREMENT PRIMARY KEY,
	communityname VARCHAR(255),
	communitydesc TEXT,
	communitystatus CHAR(4)
);

#drop table if exists communitytopic;
create table communitytopic (
	topicid INTEGER AUTO_INCREMENT PRIMARY KEY,
	communityid INTEGER,
	topicname VARCHAR(255),
	topicstatus CHAR(4)
);

#drop table if exists communitypost;
create table communitypost (
	postid INTEGER AUTO_INCREMENT PRIMARY KEY,
	topicid INTEGER,
	posttitle VARCHAR(255), 
	postbody TEXT,
	postauthorfn VARCHAR(100),
	postauthorln VARCHAR(100),
	postemail VARCHAR(100),
	postdate DATETIME,
	poststatus char(4)
);

-----Permissions for Community System
-----Requires that The Permission Tables have been created
-----See db/perm/loco_permissions.sql

insert into loco_permissions values (null, 'COMM_ADMIN');
insert into loco_permissions values (null, 'COMM_READ');
insert into loco_permissions values (null, 'COMM_ANON');

----Add permissions to the generic Admin user

insert into loco_user_perms select loco_users.userid, loco_permissions.id
from loco_users, loco_permissions where loco_users.username = 'admin' and 
loco_permissions.name = 'COMM_ADMIN'









