-- The contents of this file are subject to the Locomotive Public License 
-- (LPL), a derivative of the Mozilla Public License, version 1.0. You 
-- may not use this file except in compliance with the License; You may 
-- obtain a copy of the License at http://www.locomotive.org/license/.
-- 
-- Software distributed under the License is distributed on an "AS IS" basis, 
-- WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License 
-- for the specific language governing rights and limitations under the License. 
--
-- The initial developers of this code under the LPL is Leverage Information 
-- Systems.  Portions created by Leverage are Copyright (C) 1998 Leverage 
-- Information Systems.  All Rights reserved.
-- This is the schema for the publisher module for MySQL database

#drop table if exists loco_publisher;
create table loco_publisher (
       id		    INTEGER AUTO_INCREMENT PRIMARY KEY,
       userid		    INTEGER,
       title		    VARCHAR(64),
       modified		    DATETIME,
       status		    INTEGER,
       template		    VARCHAR(128),
       body_one		    TEXT,
       body_two		    TEXT,
       image_one	    VARCHAR(128),
       image_two	    VARCHAR(128),
       caption_one	    VARCHAR(128),
       caption_two	    VARCHAR(128)
);
      
-----Permissions for Publisher System
-----Requires that The Permission Tables have been created
-----See db/perm/loco_permissions.sql

insert into loco_permissions values (null, 'PUB_ADMIN');

----Add this permission to the generic Admin user

insert into loco_user_perms select loco_users.userid, loco_permissions.id
from loco_users, loco_permissions where loco_users.username = 'admin' and 
loco_permissions.name = 'PUB_ADMIN'
