-- The contents of this file are subject to the Locomotive Public License 
-- (LPL), a derivative of the Mozilla Public License, version 1.0. You 
-- may not use this file except in compliance with the License; You may 
-- obtain a copy of the License at http://www.locomotive.org/license/.
-- 
-- Software distributed under the License is distributed on an "AS IS" basis, 
-- WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License 
-- for the specific language governing rights and limitations under the License. 
--
-- The initial developers of this code under the LPL is Leverage Information 
-- Systems.  Portions created by Leverage are Copyright (C) 1998 Leverage 
-- Information Systems.  All Rights reserved.

/*
**      Primary Schema for the UserPrefs  demo for use with
**      Locomotive for MySQL version 3.22*/

#drop table if exists loco_user_prefs;

create table loco_user_prefs (
	user_id_ref	integer PRIMARY KEY,
	firstname	varchar(32),	
	middlename	varchar(32),
	lastname	varchar(32),
	last_login 	datetime,
	email_addr	varchar(32),
	home_addr	varchar(32),
	home_city	varchar(32),
	home_state	varchar(2),
	home_zip	varchar(9),
	home_country	varchar(32),
	work_addr	varchar(32),
        work_city	varchar(32),
	work_state	varchar(2),
	work_zip	varchar(9),
	work_country	varchar(32),
	home_ph		varchar(32),
	work_ph		varchar(32),
	passwd_hint	varchar(32),
	app_flags 	integer
   ); 

-----Permissions for UMS 
-----Requires that The Permission Tables have been created
-----See db/perm/loco_permissions.sql

insert into loco_permissions values (null, 'UMS_ADMIN');

 
----Add this permission to the generic Admin user

insert into loco_user_perms select loco_users.userid, loco_permissions.id
from loco_users, loco_permissions where loco_users.username = 'admin' and
loco_permissions.name = 'UMS_ADMIN'; 

