/*
**	Primary Schema for Bug Tracker demo for use with
**      Leverage Locomotive for Oracle 7.3
**	Copyright (c) 1998 Leverage.	All rights reserved.
*/

drop sequence btrack_bug_id_sq;
create sequence btrack_bug_id_sq start with 1;

drop sequence btrack_project_id_sq;
create sequence btrack_project_id_sq start with 1;

drop table btrack_bugs;
create table btrack_bugs (
			id NUMBER(10) PRIMARY KEY,
			project_id NUMBER(10) NOT NULL,
			version varchar(64) , 
			status varchar2(128) NOT NULL,
			severity varchar(64),
			priority NUMBER(10) NOT NULL,
			summary varchar2(128) NOT NULL,
			resolution varchar(64),
			assigned_to_user NUMBER(10),
			creator_user_id NUMBER(10) NOT NULL,
			created DATE NOT NULL,
			modified DATE NOT NULL
			) tablespace LOCO_APP_TS;

drop table btrack_bug_text;
create table btrack_bug_text (
			bug_id NUMBER(10) NOT NULL,
			text varchar2(2000),
			creator_user_id NUMBER(10) NOT NULL,
			created DATE NOT NULL
			) tablespace LOCO_APP_TS;

drop table btrack_projects;
create table btrack_projects (
			id NUMBER(10) PRIMARY KEY,
			short_title varchar2(64) UNIQUE NOT NULL,
			long_title varchar2(256),
			text varchar2(2000),
			status varchar2(128),
			creator_userid NUMBER(10) NOT NULL,
			created DATE NOT NULL,
			modified DATE NOT NULL,
			owner_userid NUMBER(10),
			mail_news_list varchar2(256)
			) tablespace LOCO_APP_TS;

create index btrack_bug_text_ix on btrack_bug_text (bug_id) tablespace LOCO_APP_TS;

drop table btrack_project_history;
create table btrack_project_history (
			id NUMBER(10) PRIMARY KEY,
			modified_by NUMBER(10) NOT NULL,
			new_info varchar2(2000) NOT NULL,
			date_modified DATE NOT NULL
			) tablespace LOCO_APP_TS;

drop table btrack_bug_history;
create table btrack_bug_history (
			id NUMBER(10) PRIMARY KEY,
			modified_by NUMBER(10) NOT NULL,
			new_info varchar2(2000) NOT NULL,
			date_modified DATE NOT NULL
			) tablespace LOCO_APP_TS;
