/*
 * The contents of this file are subject to the Locomotive Public License 
 * (LPL), a derivative of the Mozilla Public License, version 1.0. You 
 * may not use this file except in compliance with the License; You may 
 * obtain a copy of the License at http://www.locomotive.org/license/.
 * 
 * Software distributed under the License is distributed on an "AS IS" basis, 
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License 
 * for the specific language governing rights and limitations under the License. 
 *
 * The initial developers of this code under the LPL is Leverage Information 
 * Systems.  Portions created by Leverage are Copyright (C) 1998 Leverage 
 * Information Systems. All Rights reserved.
 */

/*
**	Primary Schema for Locomotive Create User for use with
**      Locomotive for Oracle 
**	This script must be run first
*/

/*
** NOTE: syntax for dropping user:
**	 This will drop the user AND all associated schema is removed 
**	 from the Data Dictionary
**
**	 DROP USER loco CASCADE;
**
**	 In order to prevent access to database revoke CREATE SESSION 
**	 privilege
**	
**	 REVOKE CREATE SESSION from loco;	
** 
*/

CREATE USER loco IDENTIFIED BY loco_pw;

GRANT CONNECT, RESOURCE TO loco;

GRANT CREATE SESSION to loco;

GRANT CREATE TABLESPACE to loco;

