-- The contents of this file are subject to the Locomotive Public License 
-- (LPL), a derivative of the Mozilla Public License, version 1.0. You 
-- may not use this file except in compliance with the License; You may 
-- obtain a copy of the License at http://www.locomotive.org/license/.
-- 
-- Software distributed under the License is distributed on an "AS IS" basis, 
-- WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License 
-- for the specific language governing rights and limitations under the License. 
--
-- The initial developers of this code under the LPL is Leverage Information 
-- Systems.  Portions created by Leverage are Copyright (C) 1998 Leverage 
-- Information Systems.  All Rights reserved.

/*
**	Primary Schema for Access Control LIST for use with the
**      Locomotive for Oracle
**	
*/

drop table LOCO_ACCESS_CONTROL_LIST;
create table LOCO_ACCESS_CONTROL_LIST 
(
	Objectid NUMBER(10) NOT NULL,
	Permission VARCHAR(32) NOT NULL,
	Userid NUMBER(10) NOT NULL,
	Groupid NUMBER(10) NOT NULL,
	Allow_Deny NUMBER(1) NOT NULL
) tablespace loco_perm_ts; 

create index LOCO_ACL_USERID on LOCO_ACCESS_CONTROL_LIST (Userid) 
	tablespace loco_perm_ts;

create index LOCO_ACL_GROUPID on LOCO_ACCESS_CONTROL_LIST (Groupid) 
	tablespace loco_perm_ts;
