-- The contents of this file are subject to the Locomotive Public License 
-- (LPL), a derivative of the Mozilla Public License, version 1.0. You 
-- may not use this file except in compliance with the License; You may 
-- obtain a copy of the License at http://www.locomotive.org/license/.
-- 
-- Software distributed under the License is distributed on an "AS IS" basis, 
-- WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License 
-- for the specific language governing rights and limitations under the License. 
--
-- The initial developers of this code under the LPL is Leverage Information 
-- Systems.  Portions created by Leverage are Copyright (C) 1998 Leverage 
-- Information Systems.  All Rights reserved.

/*
**	Primary Schema for Roles for use with
**      Locomotive for Oracle 
*/

drop sequence LOCO_ROLES_SQ;
create sequence LOCO_ROLES_SQ;

drop table LOCO_ROLES;
create table LOCO_ROLES 
(
	Id NUMBER(10) PRIMARY KEY,
	Name varchar2 (32) UNIQUE,
	perm_id NUMBER(10) REFERENCES LOCO_PERMISSIONS (ID) 
	        ON DELETE CASCADE
) tablespace loco_perm_ts;

drop table LOCO_ROLE_USERS;
create table LOCO_ROLE_USERS
(
	Userid NUMBER(10),
	Roleid NUMBER(10) REFERENCES LOCO_ROLES (ID) ON DELETE CASCADE,
	PRIMARY KEY (Roleid, Userid)
) tablespace loco_perm_ts;






