-- The contents of this file are subject to the Locomotive Public License 
-- (LPL), a derivative of the Mozilla Public License, version 1.0. You 
-- may not use this file except in compliance with the License; You may 
-- obtain a copy of the License at http://www.locomotive.org/license/.
-- 
-- Software distributed under the License is distributed on an "AS IS" basis, 
-- WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License 
-- for the specific language governing rights and limitations under the License. 
--
-- The initial developers of this code under the LPL is Leverage Information 
-- Systems.  Portions created by Leverage are Copyright (C) 1998 Leverage 
-- Information Systems.  All Rights reserved.

-- This is the schema for the publisher module for Oracle Databases

-- the publisher table space
--drop tablespace loco_publisher_ts;
--create tablespace loco_publisher_ts
--	datafile '/evol/vol01/oradata/DEVEL/datafiles/loco_publisher_ts01.dbf'
--	size 10M default storage (initial 1M next 1M pctincrease 10);

drop table loco_publisher;

create table loco_publisher (
       id		    number(10) PRIMARY KEY,
       userid		    number(10) NOT NULL,
       title		    varchar(64) NOT NULL,
       modified		    date NOT NULL,
       status		    number(1) NOT NULL,
       template		    varchar(128),
       body_one		    varchar(2000),
       body_two		    varchar(2000),
       image_one	    varchar(128),
       image_two	    varchar(128),
       caption_one	    varchar(128),
       caption_two	    varchar(128)
) tablespace loco_publisher_ts;
      
drop sequence pub_seq;
 
create sequence pub_seq start with 1;


-----Permissions for Publisher System
-----Requires that The Permission Tables have been created
-----See db/perm/loco_permissions.sql

delete from loco_permissions where name = 'PUB_ADMIN';
insert into loco_permissions values (LOCO_PERMISSIONS_SQ.nextval, 'PUB_ADMIN');

----Add this permission to the generic Admin user
delete from loco_user_perms where userid = 1 and perm_id = 
	(select id from loco_permissions where name = 'PUB_ADMIN');
insert into loco_user_perms select 1, id from loco_permissions 
	where name = 'PUB_ADMIN';

