/*
 * The contents of this file are subject to the Locomotive Public License 
 * (LPL), a derivative of the Mozilla Public License, version 1.0. You 
 * may not use this file except in compliance with the License; You may 
 * obtain a copy of the License at http://www.locomotive.org/license/.
 * 
 * Software distributed under the License is distributed on an "AS IS" basis, 
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License 
 * for the specific language governing rights and limitations under the License. 
 *
 * The initial developers of this code under the LPL is Leverage Information 
 * Systems.  Portions created by Leverage are Copyright (C) 1998 Leverage 
 * Information Systems. All Rights reserved.
 */

/*
**	Primary Schema for Session for use with
**      Locomotive for Oracle 
*/

/*
** NOTICE: deployers of the LOCOMOTIVE will want to create a minimum of 
** two tablespaces, one called 'loco_session_ts', the other  
** 'loco_user_ts'.  It is recommended that the default object size 
** in these tablespaces be at least 1Mb, and ideally they would be located
** on one or more separate devices.  Also, the database should be 
** configured to use 8k block size or larger. 
** 
** typical row length (Oracle) of the sessions table is 43 bytes.  
** typical row length (Oracle) of the users table is around 70-80 bytes.
*/

drop sequence loco_sessions_sid_sq;
create sequence loco_sessions_sid_sq;

drop table loco_sessions;
create table loco_sessions (
			sid NUMBER (20) PRIMARY KEY,
			srid NUMBER (10),
			userid NUMBER (10),
			added date,
			active date,
			expire date
		      ) tablespace loco_session_ts; 

drop table loco_session_objects;
create table loco_session_objects (
        sid NUMBER (20) PRIMARY KEY references loco_sessions (sid)
                on delete cascade,
        objects LONG RAW
        ) tablespace loco_session_ts;

