/*
 * The contents of this file are subject to the Locomotive Public License 
 * (LPL), a derivative of the Mozilla Public License, version 1.0. You 
 * may not use this file except in compliance with the License; You may 
 * obtain a copy of the License at http://www.locomotive.org/license/.
 * 
 * Software distributed under the License is distributed on an "AS IS" basis, 
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License 
 * for the specific language governing rights and limitations under the License. 
 *
 * The initial developers of this code under the LPL is Leverage Information 
 * Systems.  Portions created by Leverage are Copyright (C) 1998 Leverage 
 * Information Systems. All Rights reserved.
 */

/*
**	Sample SQL file for creating the necessary tablespaces for
**     Locomotive for Oracle 7.3.3
**
*/

/*
**  There are two recommended tablespaces, one for the sessions table, 
**  one for the users table.   If Oracle has too few block buffers, 
**  most requests to the LOCO will generate a query to each, so 
**  putting these tables on two separate devices is recommended.  For 
**  smaller deployments, one could get away with a single device, and 
**  possibly even a single tablespace.  To place these tables in a single
**  tablespace would require modification of the table creation file, 
**  loco_user_session.sql and possibly others.
*/

/*
**  Instructions:  modify the location of the datafile, the tablespace size
**  and any of the storage parameters. 
**
*/

/****** Disk 1: *******/

drop tablespace loco_user_ts;
create tablespace loco_user_ts 
    datafile '/evol/vol01/oradata/DEVEL/datafiles/loco_user_ts01.dbf'
	size 40M default storage (initial 1M next 1M pctincrease 10);

drop tablespace loco_session_ts;
create tablespace loco_session_ts
    datafile '/evol/vol01/oradata/DEVEL/datafiles/loco_session_ts01.dbf'
	size 60M default storage (initial 1M next 1M pctincrease 10);

drop tablespace loco_app_ts;
create tablespace loco_app_ts
    datafile '/evol/vol01/oradata/DEVEL/datafiles/loco_app_ts01.dbf'
	size 60M;

drop tablespace loco_perm_ts;
create tablespace loco_perm_ts
    datafile '/evol/vol01/oradata/DEVEL/datafiles/loco_perm_ts01.dbf'
	size 40M default storage (initial 1M next 1M pctincrease 10);

/*
** Tablespaces above are part of core system; below are tablespaces
** for locomodules and need to be created only if those modules will
** be used 
*/

drop tablespace loco_community_ts;
create tablespace loco_community_ts
    datafile '/evol/vol01/oradata/DEVEL/datafiles/loco_community_ts-01.dbf'
	size 50M default storage (initial 1M next 1M pctincrease 10);

drop tablespace loco_publisher_ts;
create tablespace loco_publisher_ts
    datafile '/evol/vol01/oradata/DEVEL/datafiles/loco_publisher_ts-01.dbf'
	size 40M default storage (initial 1M next 1M pctincrease 10);





