-- The contents of this file are subject to the Locomotive Public License 
-- (LPL), a derivative of the Mozilla Public License, version 1.0. You 
-- may not use this file except in compliance with the License; You may 
-- obtain a copy of the License at http://www.locomotive.org/license/.
-- 
-- Software distributed under the License is distributed on an "AS IS" basis, 
-- WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License 
-- for the specific language governing rights and limitations under the License. 
--
-- The initial developers of this code under the LPL is Leverage Information 
-- Systems.  Portions created by Leverage are Copyright (C) 1998 Leverage 
-- Information Systems.  All Rights reserved.

/*
**      Primary Schema for the UserPrefs  demo for use with
**      Locomotive for Oracle
*/

-- the user prefs table space
-- drop ablespace loco_userprefs_ts;
-- create tablespace loco_userprefs_ts
--      datafile '/evol/vol01/oradata/DEVEL/datafiles/loco_userprefs_ts01.dbf'
--      size 20M default storage (initial 1M next 1M pctincrease 10);
 


drop table loco_user_prefs;

create table loco_user_prefs (
	user_id_ref	number(10) PRIMARY KEY,
	firstname	varchar(32),	
	middlename	varchar(32),
	lastname	varchar(32),
	last_login 	date,
	email_addr	varchar(32),
	home_addr	varchar(32),
	home_city	varchar(32),
	home_state	varchar(2),
	home_zip	varchar(9),
	home_country	varchar(32),
	work_addr	varchar(32),
        work_city	varchar(32),
	work_state	varchar(2),
	work_zip	varchar(9),
	work_country	varchar(32),
	home_ph		varchar(32),
	work_ph		varchar(32),
	passwd_hint	varchar(32),
	app_flags 	integer
   ) tablespace loco_userprefs_ts;

-----Permissions for Community System
-----Requires that The Permission Tables have been created
-----See db/perm/loco_permissions.sql
 
delete from loco_permissions where name = 'UMS_ADMIN';
insert into loco_permissions(name, id) values ('UMS_ADMIN', loco_permissions_sq.nextVal);

 
----Add this permission to the generic Admin user
delete from loco_user_perms where userid = 1 and perm_id =
        (select id from loco_permissions where name = 'UMS_ADMIN');
insert into loco_user_perms select 1, id from loco_permissions
        where name = 'UMS_ADMIN';

