-- The contents of this file are subject to the Locomotive Public License 
-- (LPL), a derivative of the Mozilla Public License, version 1.0. You 
-- may not use this file except in compliance with the License; You may 
-- obtain a copy of the License at http://www.locomotive.org/license/.
-- 
-- Software distributed under the License is distributed on an "AS IS" basis, 
-- WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License 
-- for the specific language governing rights and limitations under the License. 
--
-- The initial developers of this code under the LPL is Leverage Information 
-- Systems.  Portions created by Leverage are Copyright (C) 1998 Leverage 
-- Information Systems.  All Rights reserved.





drop table btrack_ids;
create table btrack_ids (
  id_type           int2          not null  primary key,
  next_available    int4          not null
);


drop table btrack_bugs;
create table btrack_bugs (
  id                int4          not null  primary key,
  project_id        int2          not null,
  version           varchar(64),
  status            varchar(128)  not null,
  severity          varchar(64),
  priority          int2          not null,
  summary           varchar(128)  not null,
  resolution        varchar(64),
  assigned_to_user  int2,
  creator_user_id   int4          not null,
  created           timestamp     not null,
  modified          timestamp     not null
);
 

drop table btrack_bug_text;
create table btrack_bug_text (
  bug_text_id      int4       not null  primary key,
  bug_id           int4       not null,
  text             text,
  creator_user_id  int4       not null,
  created          timestamp  not null
);  


drop table btrack_projects;
create table btrack_projects (
  id              int2          not null  primary key,
  short_title     varchar(64),
  long_title      varchar(255),
  text            text,
  status          varchar(128),
  creator_userid  int4          not null,
  created         timestamp     not null,
  modified        timestamp     not null,
  owner_userid    int4,
  mail_news_list  varchar(255)
);


drop table btrack_bug_history;
create table btrack_bug_history (
  id             int4       not null  primary key,
  modified_by    int4       not null,
  new_info       text       not null,
  date_modified  timestamp  not null
);


drop table btrack_project_history;
create table btrack_project_history (
  id             int4       not null  primary key,
  modified_by    int4       not null,
  new_info       text       not null,
  date_modified  timestamp  not null
);


grant all on btrack_ids to loco;
grant all on btrack_bugs to loco;
grant all on btrack_bug_text to loco;
grant all on btrack_projects to loco;
grant all on btrack_bug_history to loco;
grant all on btrack_project_history to loco;

grant all on btrack_ids_pkey to loco;
grant all on btrack_bugs_pkey to loco;
grant all on btrack_bug_text_pkey to loco;
grant all on btrack_projects_pkey to loco;
grant all on btrack_bug_history_pkey to loco;
grant all on btrack_project_history_pkey to loco;


