
-- The contents of this file are subject to the Locomotive Public License
-- (LPL), a derivative of the Mozilla Public License, version 1.0. You
-- may not use this file except in compliance with the License; You may
-- obtain a copy of the License at http://www.locomotive.org/license/.
--
-- Software distributed under the License is distributed on an "AS IS" basis,
-- WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
-- for the specific language governing rights and limitations under the
-- License.
--
-- The initial developers of this code under the LPL is Leverage Information
-- Systems.  Portions created by Leverage are Copyright (C) 1998 Leverage
-- Information Systems. All Rights reserved.


create user loco with password loco_pw ;


drop sequence loco_bstamp_sq;
create sequence loco_bstamp_sq start 1000000;

drop sequence loco_sessions_sq;
create sequence loco_sessions_sq;

drop sequence loco_users_sq;
create sequence loco_users_sq start 10000;

-- this one's here so you can use the new id generation stuff
-- is it better to use the sequences above in postgresql?

drop table loco_ids;
create table loco_ids (
	id_type int2 primary key,
	next_available int4
);

drop table loco_sessions;
create table loco_sessions (
	sid float (15) PRIMARY KEY,
	srid int4,
	userid int4,
	added timestamp,
	active timestamp,
	expire timestamp
);


-- changed userid in loco_users table from float(10) to int4 - ee

drop table loco_users;
create table loco_users  (
	userid int4 PRIMARY KEY,
	username varchar (32) UNIQUE,
	password varchar (32),
	loco_flags int4,
	added timestamp,
	modified timestamp,
	last_login timestamp
);

insert into loco_users values (
	0, 'anonymous', '', 0, 'current_timestamp',
	'current_timestamp', 'current_timestamp'
);

insert into loco_users values (
	1, 'admin', 'changeme', 7, 'current_timestamp',
	'current_timestamp', 'current_timestamp'
);


drop table loco_session_objects;
create table loco_session_objects (
        sid float (15) PRIMARY KEY,
        objects oid
);


grant all on loco_bstamp_sq to loco ;
grant all on loco_session_objects to loco ;
grant all on loco_session_objects_pkey  to loco ;
grant all on loco_sessions to loco ;
grant all on loco_sessions_pkey to loco ;
grant all on loco_sessions_sq to loco ;
grant all on loco_users to loco ;
grant all on loco_users_pkey to loco ;
grant all on loco_users_sq to loco ;
grant all on loco_users_username_key to loco ;
grant all on loco_ids to loco ;
grant all on loco_ids_pkey to loco ;


-- to select the sequences use:
--  select nextval('loco_sessions_sq');

