-- The contents of this file are subject to the Locomotive Public License 
-- (LPL), a derivative of the Mozilla Public License, version 1.0. You 
-- may not use this file except in compliance with the License; You may 
-- obtain a copy of the License at http://www.locomotive.org/license/.
-- 
-- Software distributed under the License is distributed on an "AS IS" basis, 
-- WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License 
-- for the specific language governing rights and limitations under the License. 
--
-- The initial developers of this code under the LPL is Leverage Information 
-- Systems.  Portions created by Leverage are Copyright (C) 1998 Leverage 
-- Information Systems.  All Rights reserved.

-- Used by the Graffiti Wall Sample application
-- for SOLID Databases.  

-- create the table
drop table loco_graffiti_tags;
commit work;
create table loco_graffiti_tags (
   tag_id	integer		PRIMARY KEY,
   tag_author 	varchar(32),
   tag_text  	varchar(255),
   tag_ins_time 	timestamp
   );

-- prepopulate
insert into loco_graffiti_tags values (1, 'anon', 
   'This is an example tag', curtime());
insert into loco_graffiti_tags values (2, 'anon', 
   'This is an example tag', curtime());
insert into loco_graffiti_tags values (3, 'anon', 
   'This is an example tag', curtime());
insert into loco_graffiti_tags values (4, 'anon', 
   'This is an example tag', curtime());
insert into loco_graffiti_tags values (5, 'anon', 
   'This is an example tag', curtime());
insert into loco_graffiti_tags values (6, 'anon', 
   'This is an example tag', curtime());
insert into loco_graffiti_tags values (7, 'anon', 
   'This is an example tag', curtime());
insert into loco_graffiti_tags values (8, 'anon', 
   'This is an example tag', curtime());
insert into loco_graffiti_tags values (9, 'anon', 
   'This is an example tag', curtime());
insert into loco_graffiti_tags values (10, 'anon', 
   'This is an example tag', curtime());

-- create the sequence
drop sequence loco_graffiti_tag_id_sq;
commit work;
create sequence loco_graffiti_tag_id_sq;
commit work;

-- create temporary stored proc to set tag id sequence number to 1000
drop procedure tmp_set_tag_id;
commit work;
"create procedure tmp_set_tag_id
 returns (newval integer)
begin 
        set newval = 1000;
        exec sequence loco_graffiti_tag_id_sq set value using newval;
end";

call tmp_set_tag_id;
commit work;
drop procedure tmp_set_tag_id;
commit work;


-- create stored proc used for updating table.  Called by Tag.java
drop procedure loco_overwrite_graffiti_tag;
commit work;
"create procedure loco_overwrite_graffiti_tag (
   author varchar(32), 
   text varchar(255))
returns (next_tag_id integer)
begin 
  
  exec sequence loco_graffiti_tag_id_sq.next into next_tag_id;

  exec sql prepare foo
    update loco_graffiti_tags set tag_id = ?, tag_author = ?, tag_text = ?,
    tag_ins_time = curtime() where tag_id = (select min(tag_id) from 
    loco_graffiti_tags);
  exec sql execute foo using (next_tag_id, author, text);
  exec sql close foo;
  exec sql drop foo;

end";

commit work;
