/*
 * The contents of this file are subject to the Locomotive Public License 
 * (LPL), a derivative of the Mozilla Public License, version 1.0. You 
 * may not use this file except in compliance with the License; You may 
 * obtain a copy of the License at http://www.locomotive.org/license/.
 * 
 * Software distributed under the License is distributed on an "AS IS" basis, 
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License 
 * for the specific language governing rights and limitations under the 
 * License. 
 *
 * The initial developers of this code under the LPL is Leverage Information 
 * Systems.  Portions created by Leverage are Copyright (C) 1998 Leverage 
 * Information Systems. All Rights reserved.
 */

/***
   locolink3.cpp
   ISAPI dll which communicates with locomotive server,
   sending and receiving data.
   Author: Steve Doliov
   Date: 08/24/1998
   Copyright 1998, Leverage Information Systems Inc.
***/

#define TEXT1 "Thread 1 Making Progress<BR>"
#define TEXT2 "Thread 2 Text<BR>"

//#include < httpext.h>
#include <stdlib.h>
#include <stdio.h>
#include <io.h>
#include <fcntl.h>
#include <winsock2.h>
#include <winerror.h>
#include <memory.h>
#include <string.h>
#include <time.h>
#include <sys/types.h>
#include <sys/timeb.h>
#include "locolink3.h"
//#include "httpext.h"

BOOL WINAPI GetExtensionVersion(HSE_VERSION_INFO *pVer) {
  pVer->dwExtensionVersion = 1;
  strncpy(pVer->lpszExtensionDesc,"Locolink dll",
	      HSE_MAX_EXT_DLL_NAME_LEN);
  return TRUE;
}

DWORD WINAPI HttpExtensionProc(EXTENSION_CONTROL_BLOCK *pECB) {
  int choice;
  int conn;
  //first thing we do is check if dll has already been loaded
  //if it has not, we launch the configuration checking routine
  //(which hopefully never exits).  if the dll already has been
  //loaded, we check to see if the thread which checks the conf
  //file/memory needs to recheck this application data
  if (dllIsInitialized == NULL) {
    LPDWORD headsize;
    headsize = (LPDWORD)malloc(sizeof(DWORD));
    *headsize = 200;
    pECB->ServerSupportFunction(pECB->ConnID,
                                HSE_REQ_SEND_RESPONSE_HEADER,
                                NULL,
                                headsize,
                                NULL
                               );
	//char *hdr;
	//strcpy(hdr,"Content-type: text/html\r\n\r\n");
	//DWORD hsize = 28;
    //pECB->ServerSupportFunction(pECB->ConnID,
	//	                       HSE_REQ_SEND_RESPONSE_HEADER,
	//						   NULL,
	//						   &hsize,
	//						   (LPDWORD)hdr
	//						  );
    dllIsInitialized = (int *)malloc(sizeof(int));
	*dllIsInitialized = 0;
	locoProtocolVersion = htonl(LOCO_PROTOCOL_VERSION);
	fileData = (LPSTR)malloc(CONFIG_FILE_MAX_LENGTH*sizeof(char));
	memset(fileData,0,CONFIG_FILE_MAX_LENGTH);
	lastWriteTime = (FILETIME *)malloc(sizeof(FILETIME));
	memset(lastWriteTime,0,sizeof(FILETIME));
	numAvailLocos = (int *)malloc(sizeof(int));
	*numAvailLocos = 0;
    if (sysTime == NULL) {
	  sysTime = (LPSYSTEMTIME)malloc(sizeof(SYSTEMTIME));
	}
    (void)GetSystemTime(sysTime);
	srand(MAKEWORD(sysTime->wSecond,sysTime->wMilliseconds));
  }
  if (*dllIsInitialized == 0) {
	//need to set global HANDLE to locThreadMutex
    locThreadMutex = CreateMutex (NULL, FALSE, NULL);
	if (GetLastError() != 0) {
	  //trouble, couldn't get the locThreadMutex handle
	  //messToBrowser("Couldn't Get A Handle to the Mutex Object",pECB);
	  return HSE_STATUS_SUCCESS;
    }
    WaitForSingleObject(locThreadMutex,MAX_WAIT_TIME);
	//do the first time stuff
	//refresh is not just a first time op, but anytime the conf file needs to
	//be reread and loaded
	//messToBrowser("First Time Stuff Now Happening<BR>",pECB);
	if (!refreshAvailableLocos(pECB)) {
	  messToBrowser("Couldn't Update Locomotive Configuration ",pECB);
	  messToBrowser("Info in Initialization routine<BR>",pECB);
      ReleaseMutex(locThreadMutex);
      return HSE_STATUS_SUCCESS;
	}
	*dllIsInitialized = 1;
	//choose a locomotive
	choice = chooseLocomotive(al,loadBalScheme,pECB);
	//messToBrowser("Choosing Locomotive ",pECB);
	//messToBrowser(numToString((LONG)choice),pECB);
	//messToBrowser("<BR>",pECB);
	conn = getConnection(al,choice,pECB);
	if (conn == -1) {
	  //messToBrowser("Couldn't Get the connection<BR>",pECB);
	  return HSE_STATUS_SUCCESS;
	}
	//try to write ENV to the locomotive
	char *buf;
	buf = (char *)malloc(IO_BUF_LENGTH*sizeof(char));
	int dumInt = writeLocoEnvSendStream(conn,pECB,buf);
	//messToBrowser(numToString((LONG)dumInt),pECB);
	//messToBrowser(" bytes written to socket<BR>",pECB);
	//try to write CONTENT_LENGTH stuff to locomotive if it exists
    //DWORD sizeTBuf = 8;
    //LPSTR tBuf;
    //tBuf
    //if (pECB->GetServerVariable(pECB->ConnID,"CONTENT_LENGTH",tBuf,&sizeTBuf);
	//dumInt = writeLocoClientSTDIN(conn,(char *)pECB->lpbData);
	char **names;
	char **vals;
	names = (char **)malloc(sizeof(char *));
	vals = (char **)malloc(sizeof(char *));
    dumInt = fillLocoEnvRecvStream(conn,buf,sizeof(buf),names,vals,pECB);
	//write back to server
	//messToBrowser("Nailed it, Initialization Phase<BR>",pECB);
    closesocket(conn);
    ReleaseMutex(locThreadMutex);
	return HSE_STATUS_SUCCESS;
  } //end dll wasn't in initialized state
  else {
    WaitForSingleObject(locThreadMutex,MAX_WAIT_TIME);
	//messToBrowser("Doing non first-pass initialization stuff<BR>",pECB);
	if (!needsRefresh(pECB)) {
	  //messToBrowser("Needs Refresh function returned false<BR>",pECB);
	  //choose a locomotive
	  choice = chooseLocomotive(al,loadBalScheme,pECB);
	  //messToBrowser("Choosing locomotive #",pECB);
	  //messToBrowser(numToString((LONG)choice),pECB);
	  //messToBrowser("<BR>",pECB);
	  //write to Locomotive
	  //wait for Locomotive reply
	  //write back to server
	}
	else {
	  if (!refreshAvailableLocos(pECB)) {
	    //messToBrowser("Couldn't refresh locomotive data in non first pass",pECB);
	    //messToBrowser("Initialization routine<BR>",pECB);
	  }
	  //choose a locomotive
	  choice = chooseLocomotive(al,loadBalScheme,pECB);
	  //messToBrowser("Choosing locomotive #",pECB);
	  //messToBrowser(numToString((LONG)choice),pECB);
	  //messToBrowser("<BR>Locomotives Refreshed in non first pass Initialization<BR>",pECB);
	  //write to Locomotive
	  //wait for Locomotive reply
	  //write back to server
	}
    ReleaseMutex(locThreadMutex);
    return HSE_STATUS_SUCCESS;
  }
  return HSE_STATUS_SUCCESS;
}

BOOL WINAPI TerminateExtension(DWORD dwFlags) {
  return TRUE;
} 

BOOL confFileExists(EXTENSION_CONTROL_BLOCK *pECB) {
  confFileHandle = CreateFile(CONFIGURATION_FILE,    //the macro var which has the filename
                              GENERIC_READ,          //mode, always read only
						      0,                     //don't share it, ever
						      NULL,                  //don't care about security attributes for now
						      OPEN_EXISTING,         //only open it if it already exists
						      FILE_ATTRIBUTE_NORMAL, //let's not have this dll change the file's permissions as designated by the file's creator
						      NULL                   //we won't look at template for file attribute definitions
					         );
    LPTSTR lpMsgBuf;
	FormatMessage( 
                  FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
				  NULL,
                  GetLastError(),
                  MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
                  (LPTSTR) &lpMsgBuf,
				  0,
				  NULL
				 );
  if (confFileHandle == INVALID_HANDLE_VALUE) {
	// Display the string.
	//messToBrowser(lpMsgBuf,pECB);
	//messToBrowser("<BR>",pECB);
	(void)CloseHandle(confFileHandle);
    return FALSE;
  }
  else {
	return TRUE;
  }
}

BOOL readConfFile(LPSTR fileData,EXTENSION_CONTROL_BLOCK *pECB) {
  BOOL fileSuccessfullyRead;
  DWORD numBytesToRead = CONFIG_FILE_MAX_LENGTH;
  LPDWORD numBytesRead;
  numBytesRead = (LPDWORD)malloc(sizeof(LPDWORD));
  //zero out this buffer just in case
  memset(fileData,0,CONFIG_FILE_MAX_LENGTH);
  //check syntax conformity
  //first, dump file contents into a buffer and parse it
  fileSuccessfullyRead = ReadFile(confFileHandle,            //what we are reading
	                              fileData,                  //where we are placing the read data
								  numBytesToRead,            //how far into file will we read
								                             //note: topping out at 2K for now
							      numBytesRead,              //the actual number of bytes we read
								  NULL                       //we're not doing any overlapped reading (we better not be) 
								 );
//  if ((fileSuccessfullyRead && (*numBytesRead == 0))) {      //note: this numBytesRead == 0 is a Windows-ism
  if (fileSuccessfullyRead) {
    //messToBrowser("Read the configuration file<BR>",pECB);
	return TRUE;
  }
  else {
    LPTSTR lpMsgBuf;
	FormatMessage( 
                  FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
				  NULL,
                  GetLastError(),
                  MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
                  (LPTSTR) &lpMsgBuf,
				  0,
				  NULL
				 );
	// Display the string.
	//messToBrowser("Failed Reading Configuration File: ",pECB);
	//messToBrowser(lpMsgBuf,pECB);
	//messToBrowser("<BR>",pECB);
	return FALSE;
  }
}

BOOL fileDataLoaded(LPSTR fileData,EXTENSION_CONTROL_BLOCK *pECB) {
  char **filelines;
  char ***tokens;
  //grab some space for file lines
  //check that first file line conforms to spec, if not
  //don't bother making further malloc calls
  filelines = (char **)malloc(sizeof(char *));
  int i = 0;
  for (i = 0; i < CONFIG_FILE_MAX_LINES; i++) {
    filelines[i] = (char *)malloc(MAX_LINE_LENGTH*sizeof(char));
    //memset(filelines[i],0,sizeof(filelines[i]));
	if (i == 0) {
      filelines[i] = strtok(fileData,CONFIG_FILE_LINE_SEPS);
	  //if first line doesn't conform, don't bother reading
	  //any further lines
      if (!
	       (
	        (strcmp(filelines[0],"linear") == 0)
	                           ||
            (strcmp(filelines[0],"balance") == 0)
	       )
         )
	  {
        //error message + first line
		//regarding first line doesn't conform to spec
		//messToBrowser("First Line of Configuration File Doesn't Conform to Standard<BR>",pECB);
		//messToBrowser("First Line reads: ",pECB);
		//messToBrowser(filelines[0],pECB);
	    //messToBrowser("<BR>",pECB);
        LocalFree(filelines);
        return FALSE;
	  }
	  else {
		if (loadBalScheme == NULL) {
		  //8 chars is max of null term string "balance"
		  loadBalScheme = (LPSTR)malloc(8*sizeof(char));
		}
		memset(loadBalScheme,0,8);
		strcpy(loadBalScheme,filelines[0]);
	  }
	}
	//else the first line conforms and we'll read the remaining lines
	else {
      filelines[i] = strtok(NULL,CONFIG_FILE_LINE_SEPS);
	}
	//just an echo of the lines beyond the first which were read in
	if (filelines[i] != NULL) {
	  //messToBrowser("Line ",pECB);
	  //messToBrowser(numToString((LONG)i),pECB);
	  //messToBrowser(": ",pECB);
	  //messToBrowser(filelines[i],pECB);
	  //messToBrowser("<BR>",pECB);
	}
	else {
	  //messToBrowser("Found ",pECB);
	  //messToBrowser(numToString((LONG)(i-1)),pECB);
	  //messToBrowser(" Locomotive IP Addresses<BR>",pECB);
	  break;
	}
  }
  //now we've got all the lines, lets get the tokens
  tokens = (char ***)malloc(sizeof(char *));
  int j = 0,k = 0, l = 0;
  for (j = 1; j < i; j++) {
    tokens[(j-1)] = (char **)malloc(sizeof(char *));
    for (k = 0; k < 3; k++) {
	  //could snag less mem by writing: MAX_TOKEN_LENGTH
      tokens[(j-1)][k] = (char *)malloc(MAX_LINE_LENGTH*sizeof(char));
	}
	tokens[(j-1)][0] = strtok(filelines[j],CONFIG_FILE_FIELD_SEPS);
	//messToBrowser("Token 1: ",pECB);
	//messToBrowser(tokens[(j-1)][0],pECB);
	//messToBrowser("<BR>",pECB);
    if (tokens[(j-1)][0] != NULL) {
	  for (k = 1; k < 3; k++) {
	    tokens[(j-1)][k] = strtok(NULL,CONFIG_FILE_FIELD_SEPS);
		if (tokens[(j-1)][k] == NULL) {
		  //we got interrupted too early, there is a problem
		  //with the configuration file, kick out an error message
	      //messToBrowser("Incorrect # of Tokens on Configuration File Line #",pECB);
		  //messToBrowser(numToString((LONG)j),pECB);
	      //messToBrowser("<BR>",pECB);
          LocalFree(filelines);
          LocalFree(tokens);
		  return FALSE;
		}
		//messToBrowser("Token ",pECB);
		//messToBrowser(numToString((LONG)(k+1)),pECB);
		//messToBrowser(": ",pECB);
		//messToBrowser(tokens[(j-1)][k],pECB);
		//messToBrowser("<BR>",pECB);
	  }
    }
	else {
	  //a token was not found on a line where one was expected
	  //kick out an error message
	  //messToBrowser("A token was not found where one was expected",pECB);
      LocalFree(filelines);
      LocalFree(tokens);
      return FALSE;
	}
  }
  //now try to load data structure
  //make space for this data structure pointer to pointer
  al = NULL;
  if (al == NULL) {
    al = (struct availableLocos *)calloc((i-1),sizeof(availableLocos));
  }
  //lets populate this data structure;
  for (j = 0; j < (i-1); j++) {
	//don't hton[sl] stuff here, save that for the writing stage
    //al[j] = (struct availableLocos)malloc(sizeof(struct availableLocos));
	//memset(al[j],0,sizeof(struct availableLocos));
	al[j].ipaddr = tokens[j][0];
	al[j].port = (USHORT)atoi(tokens[j][1]);
	al[j].weight = (ULONG)atol(tokens[j][2]);
  }  //data structure successfully populated
  if (numAvailLocos == NULL) {
    numAvailLocos = (int *)malloc(sizeof(int));
  }
  *numAvailLocos = (i-1);
  LocalFree(filelines);
  LocalFree(tokens);
  //messToBrowser("There are ",pECB);
  //messToBrowser(numToString((LONG)*numAvailLocos),pECB);
  //messToBrowser(" Locomotives available<BR>",pECB);
  return TRUE;
}


BOOL needsRefresh(EXTENSION_CONTROL_BLOCK *pECB) {
  LONG comparator;
  if (!confFileExists(pECB)) {
	//messToBrowser("Refresh function can't get a handle on the Configuration File<BR>",pECB);
	return FALSE;
  }
  LPFILETIME currFileTime;
  currFileTime = (LPFILETIME)malloc(sizeof(LPFILETIME));
  //GetFileTime(confFileHandle,NULL,NULL,currFileTime);
  if (!GetFileTime(confFileHandle,NULL,NULL,currFileTime)) {
	//messToBrowser("GetFileTime function failed<BR>",pECB);
    if (!CloseHandle(confFileHandle)) {
	  //messToBrowser("Couldn't close handle after failed GetFileTime call<BR>",pECB);
	}
	return FALSE;
  }
  comparator = CompareFileTime(currFileTime,lastWriteTime);  
  if (!((-1 <= comparator) && (comparator <= 1))) {
	//messToBrowser("CompareFileTime call returned incomprehensible result<BR>",pECB);
  }
  if (!CloseHandle(confFileHandle)) {
	//messToBrowser("Couldn't Close Handle to Configuration File, Trouble<BR>",pECB);
	return FALSE;
  }
  if (comparator <= 0L) {
    return FALSE;
  }
  else {
	//remember to reset lastWriteTime
	*lastWriteTime = *currFileTime;
    return TRUE;
  }
}

//this function reads the configuration file and
//loads the data into the availableLocos data structure array
BOOL refreshAvailableLocos(EXTENSION_CONTROL_BLOCK *pECB) {
  if (!confFileExists(pECB)) {
    //trouble
	//messToBrowser("Configuration file doesn't exist where it ought to<BR>",pECB);
	return FALSE;
  }
  if (!GetFileTime(confFileHandle,NULL,NULL,lastWriteTime)) {
	//trouble
	//messToBrowser("Couldn't obtain a file time<BR>",pECB);
	//if we were able to check the file time but not get one
	//and we are returning, make sure to release the file handle
    if (!CloseHandle(confFileHandle)) {
	  //couldn't release the handle, this is trouble
	  //messToBrowser("Couldn't release the file handle after attempting to get the file time, Trouble<BR>",pECB);
	}
	return FALSE;
  }
  if (!readConfFile(fileData,pECB)) {
    //trouble
	//messToBrowser("Couldn't read the configuration file<BR>",pECB);
	//as above, remember to release the file handle before returning from
	//this function
    if (!CloseHandle(confFileHandle)) {
	  //couldn't release the handle, this is trouble
	  //messToBrowser("Couldn't release the file handle after attempting to read the file, Trouble<BR>",pECB);
	}
	return FALSE;
  }
  else {
	//we're done with the file, if we can get the file handle
	//to release, let's notify the browser and return from this
	//function
    if (!CloseHandle(confFileHandle)) {
	  //couldn't release the handle, this is trouble
	  //messToBrowser("Couldn't release the file handle after reading file, Trouble<BR>",pECB);
	  return FALSE;
	}
  }
  if (!fileDataLoaded(fileData,pECB)) {
    //trouble
	//messToBrowser("Couldn't load the file data<BR>",pECB);
	return FALSE;
  }
  //if using weighted load balancing scheme
  //let's load the preparatory info
  sumBal = 0;
  cumWeight = (int *)calloc(*numAvailLocos,sizeof(int));
  if (strcmp(loadBalScheme,"balance") == 0) {
	for (int i = 0; i < *numAvailLocos; i++) {
	  sumBal += (int)al[i].weight;
	  cumWeight[i] = sumBal;
	}
  }
  else {
    //will kick out error if algorithm tries using weighted
    //load balancing when it shouldn't be doing so
    cumWeight = NULL;
  }
  return TRUE;
}

//returns an int between 0 and (numAvailLocos - 1)
//this way we can reference the chosen Loco in array notation
//
int chooseLocomotive(availableLocos *al,LPSTR loadBalScheme,EXTENSION_CONTROL_BLOCK *pECB) {
  //choose one way if linear
  if (strcmp(loadBalScheme,"linear") == 0) {
	if (linCursor >= ((*numAvailLocos)-1)) {
	  linCursor = 0;
	  return linCursor;
	}
	else {
	  linCursor++;
	  return linCursor;
	}
  }
  //chose another way if balanced
  else {
	int select = -1;
	int i = 0;
	select = rand()%sumBal;
	LPSTR sel;
	sel = (char *)malloc(sizeof(char *));
	for (i = 0; i < *numAvailLocos; i++) {
	  if (select < cumWeight[i]) {
		break;
	  }
	}
	return i;
  }
}

SOCKET getConnection(struct availableLocos *al,int choice,EXTENSION_CONTROL_BLOCK *pECB) {
  SOCKET s;
  struct sockaddr_in sa;
  sa.sin_family = AF_INET;
  sa.sin_port = htons((USHORT)5421);
  sa.sin_addr.s_net = (char)172;    //172
  sa.sin_addr.s_host = (char)16;    //16
  sa.sin_addr.s_lh = (char)0;       //0
  sa.sin_addr.s_impno = (char)14;   //14
  //sa.sin_port = htons((USHORT)al[choice].port);
  //sa.sin_addr.S_un.S_addr = htonl(inet_addr(al[choice].ipaddr));
  //sa.sin_addr.S_un.S_addr = htonl(inet_addr("172.16.0.14"));
  s = socket(AF_INET,SOCK_STREAM,IPPROTO_TCP);
  if (s == INVALID_SOCKET) {
    //trouble
	//messToBrowser("Invalid socket<BR>",pECB);
	closesocket(s);
	return (-1);
  }
  if (connect(s,(struct sockaddr *)&sa,sizeof(struct sockaddr)) == SOCKET_ERROR) {
	//trouble
	int err = WSAGetLastError();
	//messToBrowser("Connect to socket failed, last error # was",pECB);
	//messToBrowser(numToString((LONG)err),pECB);
	//messToBrowser(". See winsock2.h for macro names of the error codes<BR>",pECB);
	closesocket(s);
	return (-1);
  }
  else {
	return s;
  }
}

int writeLocoEnvSendStream(int socketConn,EXTENSION_CONTROL_BLOCK *pECB,char *buf) {
  //host and network order of bytes to come
  ULONG hBytesToCome;
  ULONG nBytesToCome;
  int bytesWritten = 0;
  int totBytesWritten = 0;
  int bufcursor = 0;
  LPDWORD bytesInVar;
  LPSTR recvBuf;
  int isEmpty = 0;
  memset(buf,0,sizeof(buf));
  memcpy(buf,&locoProtocolVersion,4);
  bufcursor += 4;
  recvBuf = (char *)malloc(ENV_BUFFER_SIZE*sizeof(char));
  bytesInVar = (LPDWORD)malloc(sizeof(DWORD));
  *bytesInVar = ENV_BUFFER_SIZE;
  //now get the predictable (according to MS) variables
  for (int i = 0; i < PREDEFINED_ENV_VARS; i++) {
	//ugly but we have to do this -- hours of experimenation have show
	//turns out that this variable gets changed with each function call
	//rather than adhering to a notion of maximum size
    recvBuf = (char *)malloc(ENV_BUFFER_SIZE*sizeof(char));
    bytesInVar = (LPDWORD)malloc(sizeof(DWORD));
	*bytesInVar = ENV_BUFFER_SIZE;
    if(!(getEnvVar(ENVS[i],recvBuf,bytesInVar,pECB))) { 
      //the variable didn't return a comprehensible result
      //so we'll just send its name with a null value
      //ie UNIQUE_VAR=
      hBytesToCome = strlen(ENVS[i])+1;
      //strcpy(recvBuf,"\0");
      isEmpty = 1;
    }
    else {
      isEmpty = 0;
      hBytesToCome = strlen(ENVS[i])+1+strlen(recvBuf);
    }
    nBytesToCome = htonl(hBytesToCome);
    if ((bufcursor+4+hBytesToCome) > IO_BUF_LENGTH) {
      //we would overflow our buffer for sure
      //let's dump it to the socket
      //and reset everything
      bytesWritten = writeBuffer(socketConn,buf,bufcursor,0,NULL,NULL);
      if (bytesWritten == bufcursor) {
        //good, lets reset the buf and bufcursor
        memset(buf,0,sizeof(buf));
        bufcursor = 0;
        totBytesWritten += bytesWritten;
      }
      else {
        //shit, we failed the buffer write
	    messToBrowser("Failed to Flush Buffer<BR>",pECB);
  	    closesocket(socketConn);
        return (-1);
	  }
    }
    memcpy(buf+bufcursor,&nBytesToCome,4);
    bufcursor += 4;
    memcpy(buf+bufcursor,ENVS[i],strlen(ENVS[i]));
    bufcursor += strlen(ENVS[i]);
    memcpy(buf+bufcursor,"=",1);
    bufcursor++;
    if (!isEmpty) {
      memcpy(buf+bufcursor,recvBuf,strlen(recvBuf));
      bufcursor += strlen(recvBuf);
    }
    //LocalFree(recvBuf);
  } //the loop finished
  //flush remaining buffer
  bytesWritten = writeBuffer(socketConn,buf,bufcursor,0,NULL,NULL);
  //messToBrowser(numToString((LONG)bytesWritten),pECB);
  //messToBrowser(" bytes written to socket<BR>",pECB);
  totBytesWritten += bytesWritten;
  if (bytesWritten == bufcursor) {
    //good, lets reset the buf and bufcursor
    memset(buf,0,sizeof(buf));
    bufcursor = 0;
  }
  else {
    //shit, we failed the buffer write
    //messToBrowser("Failed to Flush Buffer<BR>",pECB);
  }
  //messToBrowser(numToString((LONG)bufcursor),pECB);
  //messToBrowser(" bytes written in final ENV flush<BR>",pECB);
  //closesocket(socketConn);
  //finish the protocol
  writeBuffer(socketConn,"\0\0\0\0",4,0,NULL,NULL);
  totBytesWritten += 4;
  return totBytesWritten;
}

int writeBuffer(int socketConn,char *buf,int bufcursor,int xx,struct sockaddr *sa,int x) {
  send(socketConn,buf,bufcursor,0);
  //sendto(socketConn,buf,bufcursor,0,NULL,NULL);
  //closesocket(socketConn);
  return bufcursor;
}

int writeLocoClientSTDIN(int socketConn,char *contentLength) {
  int bytes = strlen(contentLength);
  return writeBuffer(socketConn,contentLength,bytes,0,NULL,NULL);
}

int fillLocoEnvRecvStream(int socketConn,char *buf,int buflen,char **name,char **val,
						  EXTENSION_CONTROL_BLOCK *pECB) {
  int numRead = 0;
  int tot = 0;
  struct fd_set *fdSet;
  fdSet = (fd_set *)malloc(sizeof(fdSet));
  FD_ZERO(fdSet);
  fdSet->fd_count=1;
  fdSet->fd_array[0]=socketConn;
  TIMEVAL *tv;
  tv = (timeval *)malloc(sizeof(timeval));
  tv->tv_sec = MAX_SECONDS_WAIT_FOR_INPUT;
  //tv->tv_uset = MAX_MICRO_SECONDS_WAIT_FOR_INPUT;
  LPDWORD headsize;
  headsize = (LPDWORD)malloc(sizeof(DWORD));
  *headsize = 200;
  // read until you turn blue in the face
  while(select(0,fdSet,NULL,NULL,NULL) > 0)
  {
    numRead = recv(socketConn,buf,IO_BUF_LENGTH,0);
    tot += numRead;
    //but stop reading when you are at the end of the book
    if (numRead == 0) break;
  }
  /*
  pECB->ServerSupportFunction(pECB->ConnID,
                              HSE_REQ_SEND_RESPONSE_HEADER,
                              NULL,
                              headsize,
                              NULL
                             );
      //sent generic headers, now send stuff locomotive was
      //sending
  */
      messToBrowser(buf,pECB);
  return tot;
}

BOOL getEnvVar(char *varName,char *recvBuf,LPDWORD bytesInVar,EXTENSION_CONTROL_BLOCK *pECB) {
  if (!(pECB->GetServerVariable(pECB->ConnID,varName,recvBuf,bytesInVar))) {
    //bytesInVar = ENV_BUFFER_SIZE;
    switch(GetLastError()) {
      case(ERROR_NO_DATA): {
      //ignore, this is ok, we just won't pass this to locomotive
      break;
      }
	  case(ERROR_INSUFFICIENT_BUFFER): {
	    //messToBrowser("Env receive buffer to small for ",pECB);
	    //messToBrowser(varName,pECB);
        //messToBrowser("<BR>",pECB);
	    //messToBrowser(varName,pECB);
	    //messToBrowser("=",pECB);
	    if (bytesInVar != 0) {
	      //messToBrowser(recvBuf,pECB);
		  //messToBrowser("<BR>",pECB);
		}
        else {
          //messToBrowser("<BR>",pECB);
		}
	    //messToBrowser("Function Believes there are ",pECB);
	    //messToBrowser(numToString(*bytesInVar),pECB);
	    //messToBrowser(" bytes<BR>",pECB);
	    break;
        //LPSTR newB;
	    //newB = (char *)malloc(2*ENV_BUFFER_SIZE);
	    //memset(newB,0,sizeof(newB));
        //pECB->GetServerVariable(pECB->ConnID,varName,newB,bytesInVar);
	    //goto Test;
	  }
	  case(ERROR_MORE_DATA): {
	    //messToBrowser("There is more data avaialble in ",pECB);
	    //messToBrowser(varName,pECB);
	    //messToBrowser("<BR>",pECB);
	    //messToBrowser(varName,pECB);
	    //messToBrowser("=",pECB);
	    if (bytesInVar != 0) {
	      //messToBrowser(recvBuf,pECB);
	    }
	    //messToBrowser("<BR>",pECB);
        //return -1;
        break;
	  }
	  case(ERROR_INVALID_INDEX): {
	    //messToBrowser("Bad or unsupported variable identified ",pECB);
	    //messToBrowser(varName,pECB);
	    //messToBrowser("<BR>",pECB);
	    //messToBrowser(varName,pECB);
	    //messToBrowser("=",pECB);
	    //messToBrowser("<BR>",pECB);
        //return -1;
        break;
	  }
	  case(ERROR_INVALID_PARAMETER): {
	    //messToBrowser("A bad connection handle was supplied ",pECB);
	    //messToBrowser(varName,pECB);
	    //messToBrowser("<BR>",pECB);
	    //messToBrowser(varName,pECB);
	    //messToBrowser("<BR>",pECB);
        //return -1;
        break;
	  }
      default: {
	    //messToBrowser("Unknown error querying ",pECB);
	    //messToBrowser(varName,pECB);
	    //messToBrowser("<BR>",pECB);
	    //messToBrowser(varName,pECB);
	    //messToBrowser("=",pECB);
	    if (bytesInVar != 0) {
	      //messToBrowser(recvBuf,pECB);
	    }
	    //messToBrowser("<BR>",pECB);
        //return -1;
        break;
	  }
    } //end switch
    return FALSE;
  }
  //we got the environment variable without exception
  else {
    ////messToBrowser("Got the ENV vars<BR>",pECB);
    //bytes to come is 4 (the integer), + length of env var string and its data + 1 (the equals sign)
    //messToBrowser(varName,pECB);
    //messToBrowser("=",pECB);
    if (bytesInVar != 0) {
      //messToBrowser(recvBuf,pECB);
      //messToBrowser("<BR>",pECB);
    }
    else {
      //messToBrowser("<BR>",pECB);
    }
  }
  return TRUE;
}

void messToBrowser(char *s,EXTENSION_CONTROL_BLOCK *pECB) {
  DWORD textSize;
  textSize = strlen(s);
  pECB->WriteClient(pECB->ConnID,s,&textSize,0);
}

char *numToString(LONG i) {
  LPSTR x;
  x = (LPSTR)malloc(8);
  sprintf(x,"%d",i);
  return x;
}

char *hexString(char *myString) {
  LPSTR c;
  c = (char *)malloc((3*strlen(myString)*sizeof(char *))+1);
  LPSTR x;
  x = (char *)malloc(4);
  for (int i = 0; (UINT)i < strlen(myString); i++) {
	sprintf(x,"%x ",myString[i]);
    strcat(c,x);
  }
  return c;
}

/*
//the fillLoco... function if we are expecting locomotive
//to return something line 0018Content-type: text/html000cExpires: now
int fillLocoEnvRecvStream(int socketConn,char *buf,int buflen,char **name,char **val,
						  EXTENSION_CONTROL_BLOCK *pECB) {
  int cursor = 0;
  int cursor2 = 0;
  LONG tempint1 = 0;
  LONG tempint2 = 0;
  ULONG *lengthint = 0;
  lengthint = (ULONG *)malloc(sizeof(ULONG));
  *lengthint = 0;
  int index = 0;
  int numRead = 0;
  int tot = 0;
  struct fd_set *fdSet;
  fdSet = (fd_set *)malloc(sizeof(fdSet));
  FD_ZERO(fdSet);
  fdSet->fd_count=1;
  fdSet->fd_array[0]=socketConn;
  TIMEVAL *tv;
  tv = (timeval *)malloc(sizeof(timeval));
  tv->tv_sec = MAX_SECONDS_WAIT_FOR_INPUT;
  //tv->tv_uset = MAX_MICRO_SECONDS_WAIT_FOR_INPUT;
  LPDWORD headsize;
  headsize = (LPDWORD)malloc(sizeof(DWORD));
  *headsize = 200;
  char **headers;
  // read until eof
  while(select(0,fdSet,NULL,NULL,NULL) > 0)
  {
    numRead = recv(socketConn,buf,IO_BUF_LENGTH,0);
    tot += numRead;
    if (numRead == 0) break;
  }
  while(1) {
	memcpy(&tempint1,buf+cursor,4);
    *lengthint = ntohl(tempint1);
    cursor += 4;
    //if there are no extra headers around, so don't bother
    //trying to build them
    if ((*lengthint == 0) && (index == 0)) {
      pECB->ServerSupportFunction(pECB->ConnID,
                                  HSE_REQ_SEND_RESPONSE_HEADER,
                                  NULL,
                                  headsize,
                                  NULL
                                 );
      //sent generic headers, now send stuff locomotive was
      //sending
      messToBrowser(buf,pECB);
      return tot;
    }
	else if (*lengthint != 0) {
	  name[index] = (char *)malloc(((*lengthint)*sizeof(char))+1);
	  memcpy(name[index],buf+cursor,sizeof(name[index])+1);
	  cursor += *lengthint;
	  memcpy(&tempint1,buf+cursor,4);
	  *lengthint = ntohl(tempint1);
	  cursor += 4;
	  val[index] = (char *)malloc(((*lengthint)*sizeof(char))+1);
	  memcpy(val[index],buf+cursor,sizeof(val[index])+1);
	  cursor += strlen(val[index]);
	  //keep cursor2 as a placeholder, their still might be
	  //stuff in the buffer which you need to dump back to
	  //the browser;
	  cursor2 = cursor;
      index++;
    }	 
	else {
	  //no more name value pairs
      //length of header variables
	  tempint1 = 0;
	  tempint2 = 0;
      headers = (char **)calloc(index,sizeof(char *));
	  for (int i = 0; i < index; i++) {
        int acc = 0;
        int nl = 0;
        int vl = 0;
        nl = strlen(name[i]);
        vl = strlen(val[i]);
        tempint1 = nl+2+vl+2;
        headers[i] = (char *)malloc(tempint1*sizeof(char));
        memcpy(headers[i],name[i],nl);
        acc += nl;
        memcpy(headers[i]+acc,": ",2);
        acc += 2;
        memcpy(headers[i]+acc,val[i],vl);
        acc += vl;
        memcpy(headers[i]+acc,"\r\n",2);
        tempint2 += tempint1;

	  }
      break; //break the while loop
    }
    headers[index] = (char *)malloc(3);
	memcpy(headers[index],"\r\n\0",3);
    tempint2 += 2;
	//send out the headers
	//char *headers;
	//headers = (char *)malloc(sizeof(char *));
	ULONG howMuch = tempint2;
	pECB->ServerSupportFunction(pECB->ConnID,HSE_REQ_SEND_RESPONSE_HEADER,
	                            NULL,(LPDWORD)headers,&howMuch);
	//now stream Loco's STDIN back to client
    messToBrowser(buf,pECB);
    return tot;
  }
}
*/
