/*
 * The contents of this file are subject to the Locomotive Public License 
 * (LPL), a derivative of the Mozilla Public License, version 1.0. You 
 * may not use this file except in compliance with the License; You may 
 * obtain a copy of the License at http://www.locomotive.org/license/.
 * 
 * Software distributed under the License is distributed on an "AS IS" basis, 
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License 
 * for the specific language governing rights and limitations under the 
 * License. 
 *
 * The initial developers of this code under the LPL is Leverage Information 
 * Systems.  Portions created by Leverage are Copyright (C) 1998 Leverage 
 * Information Systems. All Rights reserved.
 */

#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/uio.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>
#include <netinet/in.h>

void writeRequest();
void readResponse();

int verbose = 1;

/* The address to slam */
char *c = "GET /locolink_5421/test?newsort+gaga HTTP/1.0\nCOOKIE:LOCOSID_CK_ORACLE_DEV=65_1022172509\n\n";

main (int argc, char **argv)
{
        int numloops = 100;  /* We'll make this many requests */
	int port = 80;	     /* The web server port */


        int count = 0;
        int s = 0;
        struct sockaddr_in sa;

        sa.sin_family = AF_INET;
        sa.sin_port = htons(port);  
        sa.sin_addr.s_addr = htonl(2130706433); /* is loopback address */

        while (count < numloops)
        {
                count++;

                if ((s = socket (AF_INET, SOCK_STREAM, 6)) == -1) 
                {
                        printf ("%s%s\n", "Failed to allocate socket: ", 
                                strerror (errno));
                        exit (-1);
                }
        
                if (connect (s, (struct sockaddr *) &sa, 
                        sizeof (struct sockaddr)))
                {
                        printf ("%s%s\n", "Connection Failed: ", 
                                strerror (errno));
                        exit (-1);
                }

                writeRequest(s);
                readResponse(s);
                
                close (s);
        }
}

void writeRequest (int s)
{
        extern char *c;
        if (write (s, c, strlen(c)) < 1)
        {
                printf ("ERROR: write: %s\n", strerror (errno));
                exit (-1);
        }
}

void readResponse (int s)
{
        extern int verbose;
        char buf[8192];
        int done = 0;
        int total = 0;
        int numread = 0;

        while (!done)
        {
                numread = read (s, buf, 8192);
        
                if (numread == -1)
                {
                        printf ("ERROR: read: %s\n", strerror (errno));
                        done = 1;
                }
                else if (numread == 0)
                {
                        done = 1;
                        printf ("Total Read %d bytes\n", total);
                }
                else
                {
                        total = total + numread;
                        if (verbose == 1)
                        {
                                int i = 0;
                                for (i = 0; i < numread; i++)
                                {
                                        printf ("%c", buf[i]);  
                                }
                                printf ("\n");
                        }
                }
        }
}





