/*
 * The contents of this file are subject to the Locomotive Public License 
 * (LPL), a derivative of the Mozilla Public License, version 1.0. You 
 * may not use this file except in compliance with the License; You may 
 * obtain a copy of the License at http://www.locomotive.org/license/.
 * 
 * Software distributed under the License is distributed on an "AS IS" basis, 
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License 
 * for the specific language governing rights and limitations under the 
 * License. 
 *
 * The initial developers of this code under the LPL is Candleweb AS 
 * Portions created by Candleweb AS are Copyright (C) 1999 Candleweb AS. 
 * All Rights reserved.
 */
package org.locomotive.directory;

/**
 * This interface defines a set of constants defining the different
 * types of DirectoryEvents thrown by the bean directory.
 *
 * @author Gunnar Rnning (gunnar@candleweb.no).
 * @version $Id: DirectoryEventTypes.java,v 1.1 1999/05/05 10:19:32 gunnar Exp $
 */
public interface DirectoryEventTypes {
  /** Error.  */
  public final int ERROR = 3;

  /** Warning - Potential Problem. */
  public final int WARNING = 4;

  /** Debug information. Useful for development. Equivalent to 7. */
  public final int DEBUG = 7; 
}

