/*
 * The contents of this file are subject to the Locomotive Public License 
 * (LPL), a derivative of the Mozilla Public License, version 1.0. You 
 * may not use this file except in compliance with the License; You may 
 * obtain a copy of the License at http://www.locomotive.org/license/.
 * 
 * Software distributed under the License is distributed on an "AS IS" basis, 
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License 
 * for the specific language governing rights and limitations under the 
 * License. 
 *
 * The initial developers of this code under the LPL is Candleweb AS 
 * Portions created by Candleweb AS are Copyright (C) 1999 Candleweb AS. 
 * All Rights reserved.
 */
package org.locomotive.directory;

/**
 * PropertyConverter defines an interface for converting values of one
 * object to another object. Normally the input value is a String, to 
 * some an object of the target class, but in theory the input value can
 * be anything.  PropertyConverter objects for specific classes can be 
 * registered for use by with a NameService. 
 * @see See also the NameService##addPropertyConverter()
 *
 * @author Gunnar Rnning (gunnar@candleweb.no).
 * @version $Id: PropertyConverter.java,v 1.2 1999/05/05 10:19:32 gunnar Exp $
 */
public interface PropertyConverter {
  /**
   * Convert an object of one class to an object to another class.
   * @param value The value to convert.
   * @return The object resulting from the conversion. 
   */
  public Object convertProperty(Object value);
}

