/*
 * The contents of this file are subject to the Locomotive Public License 
 * (LPL), a derivative of the Mozilla Public License, version 1.0. You 
 * may not use this file except in compliance with the License; You may 
 * obtain a copy of the License at http://www.locomotive.org/license/.
 * 
 * Software distributed under the License is distributed on an "AS IS" basis, 
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License 
 * for the specific language governing rights and limitations under the 
 * License. 
 *
 * The initial developers of this code under the LPL is Candleweb AS 
 * Portions created by Candleweb AS are Copyright (C) 1999 Candleweb AS. 
 * All Rights reserved.
 */
package org.locomotive.directory;

/**
 * This interface is provided so clients of NameService can provide 
 * an appropriate object for the requested scope type. The application
 * is through this interface able to choose any type of scope for
 * instantiated components.
 *
 * @author Gunnar Rnning (gunnar@candleweb.no).
 * @version $Id: ScopeLookup.java,v 1.3 1999/05/05 10:19:32 gunnar Exp $
 */
public interface ScopeLookup {
  /**
   * Return the appropriate object for the requested scope.
   * @param scopeType The scope type to lookup.
   * @return Returns the object defining the scope of the scope type.
   */
  public Object getScope(String scopeType);
}
