/*
 * The contents of this file are subject to the Locomotive Public License
 * (LPL), a derivative of the Mozilla Public License, version 1.0. You
 * may not use this file except in compliance with the License; You may
 * obtain a copy of the License at http://www.locomotive.org/license/.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The initial developers of this code under the LPL is Sundayta Ltd.
 * Portions created by Sundayta are Copyright (C) 1999 Sundayta Ltd.
 * All Rights reserved.
 */

package org.locomotive.loco.store.id;


import java.sql.*;
import java.math.BigInteger;


public class LocoIdJdbc extends LocoId {


  protected BigInteger getNextIdFromDatabase(int type, int increment, Connection con) throws IdException {
    BigInteger next = new BigInteger("1000");       // why is there no BigInteger(int) constructor?

    try {
      Statement stmt = con.createStatement();

      synchronized(LocoIdJdbc.class) {

        // get the existing highest id for that type
        String statement = "select next_available from loco_ids where id_type = "+type;
        ResultSet rs = stmt.executeQuery(statement);

        // is the next available id in the database?
        if (rs.next()) {
          next = (rs.getBigDecimal(1,0)).toBigInteger();
          BigInteger added = next.add(new BigInteger(""+increment));

          // set database to contain this next id plus the increment
          statement = "update loco_ids set next_available = "+
            (added)+" where id_type = "+type;
          stmt.executeUpdate(statement);

        } else {
          // the row wasn't there so we'll insert it
          statement = "insert into loco_ids (id_type, next_available) "+
            "values ("+type+", "+increment+")";
          stmt.executeUpdate(statement);
        }

        rs.close();
        stmt.close();

      }
    } catch (SQLException e) {
      e.printStackTrace();
      throw new IdException("Unable to generate id for type "+type+" - "+e);
    }


    return next;
  }
  	
	
}


