/*
 * The contents of this file are subject to the Locomotive Public License 
 * (LPL), a derivative of the Mozilla Public License, version 1.0. You 
 * may not use this file except in compliance with the License; You may 
 * obtain a copy of the License at http://www.locomotive.org/license/.
 * 
 * Software distributed under the License is distributed on an "AS IS" basis, 
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License 
 * for the specific language governing rights and limitations under the 
 * License. 
 *
 * The initial developers of this code under the LPL is Leverage Information 
 * Systems.  Portions created by Leverage are Copyright (C) 1998 Leverage 
 * Information Systems. All Rights reserved.
 */

package org.locomotive.module.userpref;

import java.lang.*;
import java.text.SimpleDateFormat;
import java.sql.*;

import org.locomotive.loco.*;
import org.locomotive.loco.handler.*;
import org.locomotive.module.base.*;
import org.locomotive.server.Log;

/**
 * This class must be entered in the handler routing table in order to
 * access the UserPref sample module.  This can be done by placing
 * the following line in your hrt.conf file: <PRE>
 *     usrpref                    org.locomotive.module.userpref.UserPrefHandler
 * </PRE>
 * @see org.locomotive.module.userpref.PersonalPrefHandler
 */

public class UserPrefHandler extends GenericHandler
{
    /** 
     * This will route a request to the UserPrefHandler or UserMgtHandler
     * class.
     * @see org.locomotive.module.userpref.UserPrefHandler#processHandler
     */
    public void handleRequest (HandlerData hd_in)
    {
	super.handleRequest(hd_in);
	hd = hd_in;

	// call the Loco library call for standard insertions.  
	StandardInsertions.insertAll (hd);

	if (url_tokens.length < 2)
	{            
	    PersonalPrefHandler ppr = new PersonalPrefHandler();
	    ppr.handleRequest(hd);
	}
	else if ( url_tokens[1].equals("personal"))
	{
	    PersonalPrefHandler ppr = new PersonalPrefHandler();
	    ppr.handleRequest(hd);
	}
	else if ( url_tokens[1].equals("manage"))
	{
	    UserMgtHandler umr = new UserMgtHandler();
	    umr.handleRequest(hd);
	}
	else
	{
	    displayPage ("error/unknown_handler_option.tmpl", steam_vars);
	}
    }
}





