/*
 * The contents of this file are subject to the Locomotive Public License
 * (LPL), a derivative of the Mozilla Public License, version 1.0. You
 * may not use this file except in compliance with the License; You may
 * obtain a copy of the License at http://www.locomotive.org/license/.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The initial developers of this code under the LPL are Sundayta Ltd.
 * Portions created by Sundayta are Copyright (C) 1999 Sundayta Ltd.
 * All Rights reserved.
 */

package org.locomotive.obf;

import org.locomotive.obf.*;
import org.locomotive.obf.event.*;
import java.util.*;



public class RefreshProcess implements BusinessProcess {

  public static final int INSERT  = 0;
  public static final int UPDATE  = 1;
  public static final int DELETE  = 2;
  public static final int REFRESH = 3;


  private int type;
  private UidBusinessObject busObject;
  private Class busClass;

  public RefreshProcess(int t, UidBusinessObject o, Class c) {
    type = t;
    busObject = o;
    busClass = c;
  }


  public int getType() {
    return type;
  }

  public void setType(int t) {
    type = t;
  }


  public UidBusinessObject getBusinessObject() {
    return busObject;
  }

  public void setBusinessObject(UidBusinessObject o) {
    busObject = o;
  }


  public Class getBusClass() {
    return busClass;
  }

  public void setBusClass(Class c) {
    busClass = c;
  }





}


