/*
 * The contents of this file are subject to the Locomotive Public License
 * (LPL), a derivative of the Mozilla Public License, version 1.0. You
 * may not use this file except in compliance with the License; You may
 * obtain a copy of the License at http://www.locomotive.org/license/.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The initial developers of this code under the LPL are Sundayta Ltd.
 * Portions created by Sundayta are Copyright (C) 1999 Sundayta Ltd.
 * All Rights reserved.
 */

package org.locomotive.obf;

import org.locomotive.obf.server.ConnectionToClient;


public class RemoveClientListenerProcess implements BusinessProcess {

  public static final int LOCAL = 0;
  public static final int HTTP  = 1;

  private String url;
  private int type, port;
  private Class busClass;
  private ConnectionToClient con;



  public RemoveClientListenerProcess(ConnectionToClient con) {
    type = LOCAL;
    this.con = con;
  }

  public RemoveClientListenerProcess(ConnectionToClient con, Class busClass) {
    type = LOCAL;
    this.con      = con;
    this.busClass = busClass;
  }

  public RemoveClientListenerProcess(String url, int port) {
    type = HTTP;
    this.url      = url;
    this.port     = port;
  }

  public RemoveClientListenerProcess(String url, int port, Class busClass) {
    type = HTTP;
    this.url      = url;
    this.port     = port;
    this.busClass = busClass;
  }


  public int getType() {
    return type;
  }

  public Class getBusClass() {
    return busClass;
  }

  public ConnectionToClient getLocalConnection() {
    return con;
  }

  public String getUrl() {
    return url;
  }

  public int getPort() {
    return port;
  }



}
