/*
 * The contents of this file are subject to the Locomotive Public License
 * (LPL), a derivative of the Mozilla Public License, version 1.0. You
 * may not use this file except in compliance with the License; You may
 * obtain a copy of the License at http://www.locomotive.org/license/.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The initial developers of this code under the LPL are Sundayta Ltd.
 * Portions created by Sundayta are Copyright (C) 1999 Sundayta Ltd.
 * All Rights reserved.
 */

package org.locomotive.obf.client;

import org.locomotive.obf.*;
import org.locomotive.obf.data.UniqueId;
import java.util.Vector;


import java.io.*;
import java.net.*;

/**
 * This class is part of the implentation for notifying clients of refreshes
 * over an HTTP connection.  It is not complete yet.
 */

public class ClientHttpMonitor extends Thread {

  private String url;
  private ServerSocket ss;
  private int backlog = 8;
  private ConnectionToHttpServer con;


  ClientHttpMonitor(int port, ConnectionToHttpServer con) {
    this.con = con;

    try {
      ss = new ServerSocket(port, backlog);
    } catch (IOException e) {
      e.printStackTrace();
      //throw new ConnectionToServerException(""+e);
    }
  }


  public void run() {


    System.out.println("ClientHttpMonitor running");

    while (true) {

      try {
        Socket sock = ss.accept();

        System.out.println("Got connection!");

        //PooledThread pt = tpm.getPooledThread ();
        //ClientConnection cc = new ClientConnection(this, cs, connections);
        //pt.loadRunnable(cc);
        //pt.go();

        handleConnection(sock);


      } catch (IOException e) {
        System.err.println("Init Failed with ioexception: " + e);
        System.exit(-1);
      }

    }

  }

  


  private void handleConnection(Socket sock) {

    RefreshProcess proc = null;
    ObjectInputStream in = null;


    try {

      in = new ObjectInputStream(sock.getInputStream());


      proc = (RefreshProcess) in.readObject();

      if (proc != null) {
        System.out.println("* received "+proc.getClass().getName()+" from server");
      } else {
        System.out.println("* received null from server");
      }

    //} catch (ClassNotFoundException e) {
    //} catch (IOException e) {
    } catch (Exception e) {
      e.printStackTrace();
      System.out.println("Client dying!");
      System.exit(0);
    }

    // tidy up
    try { in.close(); } catch (Exception e) {}


    // now deal with it!

    if (proc != null) {

      switch(proc.getType()) {
      case RefreshProcess.INSERT:
        con.notifyClientOfInsert(proc.getBusinessObject());
        break;
      case RefreshProcess.UPDATE:
        con.notifyClientOfUpdate(proc.getBusinessObject());
        break;
      case RefreshProcess.DELETE:
        con.notifyClientOfDelete(proc.getBusinessObject());
        break;
      case RefreshProcess.REFRESH:
        con.notifyClientOfRefresh(proc.getBusClass());
        break;
      }

    }

    System.out.println("*** dealt with "+proc+"?");

  }







/*
  private ObjectInputStream establishConnection() throws MalformedURLException, IOException {
    URLConnection uc = new URL(url+"?monitor").openConnection();
    uc.setUseCaches(false);
    uc.setDoOutput(true);
    uc.setDoInput(true);
    uc.setRequestProperty("Content-type", "application/octet-stream");

    ObjectOutputStream out = new ObjectOutputStream(uc.getOutputStream());
    out.flush();

    uc.connect();
    return new ObjectInputStream(uc.getInputStream());
  }




  private void receiveUpdate(ObjectInputStream in) throws IOException {
    try {
      Object reply = in.readObject();
      System.out.print(".");
    } catch (ClassNotFoundException e) {
      // do something
    }
  }


//    manager.updatedObject(busObject);
//    manager.insertedObject(busObject);
//    manager.deletedObject(busObject);
//    manager.refreshObjects(busClass);

*/
}
