/*
 * The contents of this file are subject to the Locomotive Public License
 * (LPL), a derivative of the Mozilla Public License, version 1.0. You
 * may not use this file except in compliance with the License; You may
 * obtain a copy of the License at http://www.locomotive.org/license/.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The initial developers of this code under the LPL are Sundayta Ltd.
 * Portions created by Sundayta are Copyright (C) 1999 Sundayta Ltd.
 * All Rights reserved.
 */

package org.locomotive.obf.client.event;

import java.util.*;

public class DataEntryModeChangeEvent extends EventObject {
  public static final byte BROWSE = 0;
  public static final byte EDIT = 1;
  public static final byte NEW = 2;

  protected byte _oldMode;
	protected byte _newMode;

	public DataEntryModeChangeEvent(Object source, byte oldMode, byte newMode) {
		super(source);
		_oldMode = oldMode;
		_newMode = newMode;
	}

	public byte getOldMode() { return _oldMode; }
	public byte getNewMode() { return _newMode; }
}
