/*
 * The contents of this file are subject to the Locomotive Public License
 * (LPL), a derivative of the Mozilla Public License, version 1.0. You
 * may not use this file except in compliance with the License; You may
 * obtain a copy of the License at http://www.locomotive.org/license/.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The initial developers of this code under the LPL are Sundayta Ltd.
 * Portions created by Sundayta are Copyright (C) 1999 Sundayta Ltd.
 * All Rights reserved.
 */

package org.locomotive.obf.client.swing;

import java.awt.Color;
import javax.swing.JLabel;
import org.locomotive.obf.data.*;
import org.locomotive.obf.event.*;



public abstract class AbstractObfLabel extends JLabel implements DisplayField, ModificationListener {

  //private static final char WIDEST_CHAR = 'W';

  protected DataObject data;


  public AbstractObfLabel(int width, int align) {
    super("", align);
    setForeground(Color.black);

    //Dimension d = forceMinimumSize(width);
    //setMinimumSize(d);
    //setMaximumSize(d);
    //setPreferredSize(d);
  }

/*  
  private Dimension forceMinimumSize(int chars) {
    char[] c = new char[chars];
    for (int x=0; x<chars; x++) c[x] = WIDEST_CHAR;
    return (new JLabel(new String(c))).getPreferredSize();
  }
*/
  

  public DataObject getDataObject() {
    return data;
  }


  public void setDataObject(DataObject o) {

    if (o != null && o.getClass() != getDataObjectClass())
      throw new IllegalArgumentException("setDataObject method in "+getClass().getName()+" was passed "+o.getClass().getName()+", expected "+getDataObjectClass().getName());
     
    if (data instanceof Modifiable)
      ((Modifiable) data).removeModificationListener(this);
    data = o;
    if (data instanceof Modifiable)
      ((Modifiable) data).addModificationListener(this);

    displayData();
  }


  public void setText(String str) {
    super.setText(str == null || str.equals("") ? " " : str);
  }

  public void modified(ModificationEvent me) {
    displayData();
  }


  abstract protected void displayData();


}
