/*
 * The contents of this file are subject to the Locomotive Public License
 * (LPL), a derivative of the Mozilla Public License, version 1.0. You
 * may not use this file except in compliance with the License; You may
 * obtain a copy of the License at http://www.locomotive.org/license/.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The initial developers of this code under the LPL are Sundayta Ltd.
 * Portions created by Sundayta are Copyright (C) 1999 Sundayta Ltd.
 * All Rights reserved.
 */

package org.locomotive.obf.client.swing;


import org.locomotive.obf.data.DateDocument;


/**
 * A text field component to display and edit <code>DateDocument</code> objects
 *
 */


public class DateField extends AbstractObfTextField {

  
  public DateField() {
    this(null, 10);
  }

  public DateField(int width) {
    this(null, width);
  }

	public DateField(DateDocument doc) {
    this(doc, 10);
  }

	public DateField(DateDocument doc, int width) {
		super(width);
    setDataObject(doc);
	}


  public Class getDataObjectClass() {
    return DateDocument.class;
  }


}
