/*
 * The contents of this file are subject to the Locomotive Public License
 * (LPL), a derivative of the Mozilla Public License, version 1.0. You
 * may not use this file except in compliance with the License; You may
 * obtain a copy of the License at http://www.locomotive.org/license/.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The initial developers of this code under the LPL are Sundayta Ltd.
 * Portions created by Sundayta are Copyright (C) 1999 Sundayta Ltd.
 * All Rights reserved.
 */

package org.locomotive.obf.client.swing;

import org.locomotive.obf.data.*;

/**
 * Label to display <code>EnumModel</code> objects
 */


public class EnumLabel extends AbstractObfLabel {

  protected String[] captions;

  public EnumLabel(String[] c) {
    this(c, null, 10);
  }

  public EnumLabel(String[] c, int width) {
    this(c, null, width);
  }

  public EnumLabel(String[] c, EnumModel model) {
    this(c, model, 10);
  }
    
  public EnumLabel(String[] c, EnumModel model, int width) {
    super(width, LEFT);
    captions = c;
    setDataObject(model);
  }


  public Class getDataObjectClass() {
    return EnumModel.class;
  }

  protected void displayData() {
    if (data == null || data.getData() == null) {
      setText(" ");
    } else {
      int i = ((Integer) data.getData()).intValue();
      if (captions != null && i < captions.length)
        setText(captions[i]);
      else
        setText(""+i);
    }
  }

}
