/*
 * The contents of this file are subject to the Locomotive Public License
 * (LPL), a derivative of the Mozilla Public License, version 1.0. You
 * may not use this file except in compliance with the License; You may
 * obtain a copy of the License at http://www.locomotive.org/license/.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The initial developers of this code under the LPL are Sundayta Ltd.
 * Portions created by Sundayta are Copyright (C) 1999 Sundayta Ltd.
 * All Rights reserved.
 */

package org.locomotive.obf.client.swing;


import org.locomotive.obf.BusinessObject;
import org.locomotive.obf.client.*;
import org.locomotive.obf.client.event.*;
import javax.swing.JPanel;

/**
 * A panel that provides a view onto a constant business object.  This
 * business object is fixed in the constructor and the panel will always look
 * at that one object, although the object's state may change.
 * The panel should provide a means of editing or viewing this object.
 * <br> A <code>VariablePanel</code> should be used to display different
 * business objects otherwise a new <code>FixedPanel</code> must be created
 * every time there is a new business object.
 *
 * @author Erik Erskine
 * @see    VariablePanel
 */

public abstract class FixedPanel extends AbstractPanel {


  /**
   * Creates a new panel looking at the specified business object.
   */

  protected FixedPanel(BusinessObject o) {
    busObject = o;
  }

}

