/*
 * The contents of this file are subject to the Locomotive Public License
 * (LPL), a derivative of the Mozilla Public License, version 1.0. You
 * may not use this file except in compliance with the License; You may
 * obtain a copy of the License at http://www.locomotive.org/license/.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The initial developers of this code under the LPL are Sundayta Ltd.
 * Portions created by Sundayta are Copyright (C) 1999 Sundayta Ltd.
 * All Rights reserved.
 */

package org.locomotive.obf.client.swing;

import org.locomotive.obf.data.*;


/**
 * Label to display <code>StringDocument</code> objects
 */


public class StringLabel extends AbstractObfLabel {

  public StringLabel() {
    this(null, 10);
  }

  public StringLabel(int width) {
    this(null, width);
  }

  public StringLabel(StringDocument doc) {
    this(doc, 10);
  }
    
  public StringLabel(StringDocument doc, int width) {
    super(width, LEFT);
    setDataObject(doc);
  }


  public Class getDataObjectClass() {
    return StringDocument.class;
  }

  public void displayData() {
    if (data == null || data.getData() == null)
      setText(" ");
    else
      setText((String) data.getData());
  }


}
