/*
 * The contents of this file are subject to the Locomotive Public License
 * (LPL), a derivative of the Mozilla Public License, version 1.0. You
 * may not use this file except in compliance with the License; You may
 * obtain a copy of the License at http://www.locomotive.org/license/.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The initial developers of this code under the LPL are Sundayta Ltd.
 * Portions created by Sundayta are Copyright (C) 1999 Sundayta Ltd.
 * All Rights reserved.
 */

package org.locomotive.obf.example;


import org.locomotive.obf.*;
import org.locomotive.obf.client.*;
import org.locomotive.obf.server.*;
import org.locomotive.server.*;
import java.sql.*;


import javax.swing.*;
import javax.swing.border.*;
import java.awt.*;
import java.applet.*;
import java.util.*;




public class Example extends JFrame {

  private static ObfManager mgr;



  public Example(JPanel p) {
    getContentPane().add(p, BorderLayout.CENTER);
    setTitle("Obf Example");
    pack();
    setVisible(true);
  }


  private static void syntaxError() {
    System.out.println("Syntax for local connection:");
    System.out.println("  java org.locomotive.obf.example.Example local <driver> <jdbc url> <user> <password>");
    System.out.println("");
    System.out.println("Syntax for remote connection over http:");
    System.out.println("  java org.locomotive.obf.example.Example http <url> <client url> <client port>");
    System.out.println("  where <url> is the locomotive server eg, http://acts.sundayta.co.uk/cgi-bin/locolink-7121/servlet/obf");
    System.exit(0);
  }

  public static void main(String[] args) {
    boolean local = true;

    mgr = ObfManager.getInstance();
    System.out.println("here");

    if (args.length < 1)
      syntaxError();
    
    if (args[0].equals("local")) {
      if (args.length < 4)
        syntaxError();

      String jdbcDriver = args[1];
      String url        = args[2];
      String user       = args[3];
      String password   = args.length > 4 ? args[4] : "";

      ServerSupporter.getInstance().initializeLocalDatabase(jdbcDriver, url, user, password);

      LocalConnection localConnection = new LocalConnection();

      //c.setClientListener(mgr);
      mgr.setConnection(localConnection.getConnectionToServer());


    } else if (args[0].equals("http")) {
      if (args.length < 2)
        syntaxError();
      
      String url        = args[1];
      String clientUrl  = args[2];
      int    clientPort = Integer.parseInt(args[3]);
      local = false;

      mgr.setConnection(new ConnectionToHttpServer(mgr, url, clientUrl, clientPort));

    } else
      syntaxError();

    //----------

    new Example(new ExampleController((ObfManager) mgr).getForm());
    new Example(new ExampleController((ObfManager) mgr).getForm());
  }


}

