/*
 * The contents of this file are subject to the Locomotive Public License
 * (LPL), a derivative of the Mozilla Public License, version 1.0. You
 * may not use this file except in compliance with the License; You may
 * obtain a copy of the License at http://www.locomotive.org/license/.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The initial developers of this code under the LPL are Sundayta Ltd.
 * Portions created by Sundayta are Copyright (C) 1999 Sundayta Ltd.
 * All Rights reserved.
 */

package org.locomotive.obf.example;


import org.locomotive.obf.*;
import org.locomotive.obf.client.*;
import org.locomotive.obf.client.swing.*;
import javax.swing.*;
import java.awt.*;


public class ExampleBrowsePanel extends VariablePanel { 

  private StringLabel  nameLabel    = new StringLabel();
  private DateLabel    dateLabel    = new DateLabel();
  private IntegerLabel valueLabel   = new IntegerLabel();
  private EnumLabel    statusLabel  = new EnumLabel(ExampleRwBusinessObject.STATUS);
  private BooleanLabel checkedLabel = new BooleanLabel();


  public ExampleBrowsePanel(DataEntryController c) {
    super(ExampleRwBusinessObject.class, c);
    
    setLayout(new GridBagLayout());
    GridBagConstraints gbc = new GridBagConstraints();

    gbc.gridx = 0;
    gbc.gridwidth = 1;
    gbc.gridheight = 1;
    gbc.weightx = 1.0;
    gbc.weighty = 0.0;
    gbc.anchor = GridBagConstraints.NORTHWEST;

    gbc.fill = GridBagConstraints.HORIZONTAL;
    gbc.gridy = 0; gbc.insets = new Insets(0,0,0,0);  add(new JLabel("Name"), gbc);
    gbc.gridy++;   gbc.insets = new Insets(0,10,0,0); add(nameLabel, gbc);

    gbc.fill = GridBagConstraints.NONE;
    gbc.gridy++;   gbc.insets = new Insets(10,0,0,0);  add(new JLabel("Date"), gbc);
    gbc.gridy++;   gbc.insets = new Insets(5,10,0,0); add(dateLabel, gbc);

    gbc.gridy++;   gbc.insets = new Insets(10,0,0,0);  add(new JLabel("Value"), gbc);
    gbc.gridy++;   gbc.insets = new Insets(5,10,0,0); add(valueLabel, gbc);

    gbc.gridy++;   gbc.insets = new Insets(10,0,0,0);  add(new JLabel("Status"), gbc);
    gbc.gridy++;   gbc.insets = new Insets(5,10,0,0); add(statusLabel, gbc);

    gbc.gridy++;   gbc.insets = new Insets(10,0,0,0);  add(new JLabel("Checked"), gbc);
    gbc.weighty = 1.0;
    gbc.gridy++;   gbc.insets = new Insets(5,10,0,0); add(checkedLabel, gbc);

  }


  public void setBusinessObject(BusinessObject o) {
    busObject = o;
    ExampleRwBusinessObject e = (ExampleRwBusinessObject) o;
    if (e != null) {
      nameLabel.setDataObject(e.getName());
      dateLabel.setDataObject(e.getDate());
      valueLabel.setDataObject(e.getValue());
      statusLabel.setDataObject(e.getStatus());
      checkedLabel.setDataObject(e.getChecked());
    }
  }

}


