/*
 * The contents of this file are subject to the Locomotive Public License
 * (LPL), a derivative of the Mozilla Public License, version 1.0. You
 * may not use this file except in compliance with the License; You may
 * obtain a copy of the License at http://www.locomotive.org/license/.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The initial developers of this code under the LPL are Sundayta Ltd.
 * Portions created by Sundayta are Copyright (C) 1999 Sundayta Ltd.
 * All Rights reserved.
 */

package org.locomotive.obf.example;


import org.locomotive.obf.*;
import org.locomotive.obf.client.*;
import org.locomotive.obf.client.swing.*;
import javax.swing.*;
import java.awt.*;


public class ExampleEditPanel extends VariablePanel { 

  private StringField       nameField    = new StringField();
  private DateField         dateField    = new DateField();
  private IntegerField      valueField   = new IntegerField();
  private EnumRadioField    statusField  = new EnumRadioField(ExampleRwBusinessObject.STATUS);
  private BooleanRadioField checkedField = new BooleanRadioField();


  public ExampleEditPanel(DataEntryController c) {
    super(ExampleRwBusinessObject.class, c);
    
    setLayout(new GridBagLayout());
    GridBagConstraints gbc = new GridBagConstraints();

    gbc.gridx = 0;
    gbc.gridwidth = 1;
    gbc.gridheight = 1;
    gbc.weightx = 1.0;
    gbc.weighty = 0.0;
    gbc.anchor = GridBagConstraints.NORTHWEST;

    gbc.fill = GridBagConstraints.HORIZONTAL;
    gbc.gridy = 0; gbc.insets = new Insets(0,0,0,0);   add(new JLabel("Name"), gbc);
    gbc.gridy++;   gbc.insets = new Insets(0,10,0,0);  add(nameField, gbc);

    gbc.fill = GridBagConstraints.NONE;
    gbc.gridy++;   gbc.insets = new Insets(10,0,0,0);  add(new JLabel("Date"), gbc);
    gbc.gridy++;   gbc.insets = new Insets(5,10,0,0);  add(dateField, gbc);

    gbc.gridy++;   gbc.insets = new Insets(10,0,0,0);  add(new JLabel("Value"), gbc);
    gbc.gridy++;   gbc.insets = new Insets(5,10,0,0);  add(valueField, gbc);

    gbc.gridy++;   gbc.insets = new Insets(10,0,0,0);  add(new JLabel("Status"), gbc);
    gbc.gridy++;   gbc.insets = new Insets(5,10,0,0);  add(statusField, gbc);

    gbc.gridy++;   gbc.insets = new Insets(10,0,0,0);  add(new JLabel("Checked"), gbc);
    gbc.weighty = 1.0;
    gbc.gridy++;   gbc.insets = new Insets(5,10,0,0);  add(checkedField, gbc);

  }


  public void setBusinessObject(BusinessObject o) {
    busObject = o;
    ExampleRwBusinessObject e = (ExampleRwBusinessObject) o;
    if (e != null) {
      nameField.setDataObject(e.getName());
      dateField.setDataObject(e.getDate());
      valueField.setDataObject(e.getValue());
      statusField.setDataObject(e.getStatus());
      checkedField.setDataObject(e.getChecked());
    }
  }

}


