/*
 * The contents of this file are subject to the Locomotive Public License
 * (LPL), a derivative of the Mozilla Public License, version 1.0. You
 * may not use this file except in compliance with the License; You may
 * obtain a copy of the License at http://www.locomotive.org/license/.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The initial developers of this code under the LPL are Sundayta Ltd.
 * Portions created by Sundayta are Copyright (C) 1999 Sundayta Ltd.
 * All Rights reserved.
 */

package org.locomotive.obf.example;


import org.locomotive.obf.*;
import org.locomotive.obf.data.*;


public class ExampleLbBusinessObject implements ListBoxBusinessObject {

  private UniqueStringId code;
  private String            name;



  public ExampleLbBusinessObject(UniqueStringId c, String n) {
    code = c;
    name = n;
  }

  public ExampleLbBusinessObject(String c, String n) {
    this(UniqueStringId.create(c), n);
  }

  public ExampleLbBusinessObject() {
    this((UniqueStringId) null, null);
  }


  public int       getColumnCount()           { return 1; }
  public String[]  getColumnNames()           { return new String[]  {"Name"}; }
  public int[]     getDefaultSortColumns()    { return new int[]     {0}; }
  public boolean[] getDefaultSortDirections() { return new boolean[] {true}; }


  public Object getColumnObject(int col) {
    switch (col) {
    case 0: return name;
    }
    return null;
  }


  public UniqueId getUniqueId() {
    return code;
  }

  public void setUniqueId(UniqueId u) {
    // not supported?
  }


  public String toString() {
    return getClass().getName() + "[code="+code+",name="+name+"]";
  }


}


