/*
 * The contents of this file are subject to the Locomotive Public License
 * (LPL), a derivative of the Mozilla Public License, version 1.0. You
 * may not use this file except in compliance with the License; You may
 * obtain a copy of the License at http://www.locomotive.org/license/.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The initial developers of this code under the LPL are Sundayta Ltd.
 * Portions created by Sundayta are Copyright (C) 1999 Sundayta Ltd.
 * All Rights reserved.
 */

package org.locomotive.obf.server;

import org.locomotive.obf.*;
import java.sql.Connection;


public class AddClientListenerProcessHandler implements ProcessHandler {


  public Object doProcess(BusinessProcess process, Connection con) {

    AddClientListenerProcess ap = (AddClientListenerProcess) process;

    // Get a connection to the client based on the process
    ConnectionToClient client = null;

    if (ap.getType() == AddClientListenerProcess.LOCAL) {
      client = ap.getLocalConnection();

    } else if (ap.getType() == AddClientListenerProcess.HTTP) {
      // maybe better to get these clients from the
      // server supporter or somewhere that caches them
      System.out.println("*** client is "+ap.getUrl()+" on port "+ap.getPort());
      client = new ConnectionToHttpClient(ap.getUrl(), ap.getPort());

    }

    ClientNotificationQueue.getInstance().
      addRefreshListener(client, ap.getBusClass());

    return null;
  }


}
