/*
 * The contents of this file are subject to the Locomotive Public License
 * (LPL), a derivative of the Mozilla Public License, version 1.0. You
 * may not use this file except in compliance with the License; You may
 * obtain a copy of the License at http://www.locomotive.org/license/.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The initial developers of this code under the LPL are Sundayta Ltd.
 * Portions created by Sundayta are Copyright (C) 1999 Sundayta Ltd.
 * All Rights reserved.
 */

package org.locomotive.obf.server;

import java.sql.Connection;


/**
 * The listener interface for receiving instructions
 * to reload business objects.
 *
 * @author Erik Erskine
 * @author David Warnock
 * @see    ReloadNotice
 * @see    ReloadQueue 
 */

public interface ReloadListener {

  /**
   * Invoked when there is an instruction to reload one or more
   * business objects.
   *
   * @param      notice the instruction of what to reload
   * @param      con a database connection to use
   */

  public void reload(ReloadNotice notice, Connection con);

}

