/*
 * The contents of this file are subject to the Locomotive Public License
 * (LPL), a derivative of the Mozilla Public License, version 1.0. You
 * may not use this file except in compliance with the License; You may
 * obtain a copy of the License at http://www.locomotive.org/license/.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The initial developers of this code under the LPL are Sundayta Ltd.
 * Portions created by Sundayta are Copyright (C) 1999 Sundayta Ltd.
 * All Rights reserved.
 */

package org.locomotive.obf.server;

import org.locomotive.obf.*;
import org.locomotive.obf.data.UniqueId;
import java.util.Vector;
import java.util.Enumeration;
import java.sql.Connection;
import java.sql.SQLException;


public class RemoveClientListenerProcessHandler implements ProcessHandler {


  public Object doProcess(BusinessProcess process, Connection con) {

    RemoveClientListenerProcess rp = (RemoveClientListenerProcess) process;

    // Get a connection to the client based on the process
    ConnectionToClient client = null;

    if (rp.getType() == RemoveClientListenerProcess.LOCAL) {
      client = rp.getLocalConnection();

    } else if (rp.getType() == RemoveClientListenerProcess.HTTP) {
      // maybe better to get these clients from the
      // server supporter or somewhere that caches them
      client = new ConnectionToHttpClient(rp.getUrl(), rp.getPort());

    }

    ClientNotificationQueue.getInstance().
      removeRefreshListener(client, rp.getBusClass());

    return null;

  }


}
