/*
 * The contents of this file are subject to the Locomotive Public License 
 * (LPL), a derivative of the Mozilla Public License, version 1.0. You 
 * may not use this file except in compliance with the License; You may 
 * obtain a copy of the License at http://www.locomotive.org/license/.
 * 
 * Software distributed under the License is distributed on an "AS IS" basis, 
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License 
 * for the specific language governing rights and limitations under the 
 * License. 
 *
 * The initial developers of this code under the LPL is Leverage Information 
 * Systems.  Portions created by Leverage are Copyright (C) 2000 Leverage 
 * Information Systems. All Rights reserved.
 */

package org.locomotive.servlets.test;

import org.locomotive.loco.*;
import org.locomotive.servlets.MultiThreadedHttpServlet;
import org.locomotive.server.Log;

import javax.servlet.*;
import javax.servlet.http.*;

import java.io.*;
import java.util.Hashtable;


/** 
 * This servlet is a test servlet that always throws a permanent
 * UnavailableException during any call to the service() method in an
 * attempt to tell the servlet container that this multithreaded servlet
 * instance should be taken out of service.
 *
 * @author Jason Brittain <brittainj@diamtech.com>
 */
public class PermanentlyUnavailable2 extends MultiThreadedHttpServlet
{
    public void doGet(HttpServletRequest request, HttpServletResponse response)
	throws ServletException, IOException
    {
	// Always throw an UnavailableException during service()!
	throw new UnavailableException(this, "Just Testing..");

	// FIXME: For Servlet 2.2 compliance, comment out the one above, and
	// uncomment this:
	//throw new UnavailableException("Just Testing..");
    }
    
    public void doPost(HttpServletRequest request,
		       HttpServletResponse response)
	throws ServletException, IOException
    {
	doGet(request, response);
    }
}
