/*
 * The contents of this file are subject to the Locomotive Public License 
 * (LPL), a derivative of the Mozilla Public License, version 1.0. You 
 * may not use this file except in compliance with the License; You may 
 * obtain a copy of the License at http://www.locomotive.org/license/.
 * 
 * Software distributed under the License is distributed on an "AS IS" basis, 
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License 
 * for the specific language governing rights and limitations under the 
 * License. 
 *
 * The initial developers of this code under the LPL is Leverage Information 
 * Systems.  Portions created by Leverage are Copyright (C) 2000 Leverage 
 * Information Systems. All Rights reserved.
 */

package org.locomotive.servlets.test;

import javax.servlet.*;
import javax.servlet.http.*;

import java.io.*;


/** 
 * This servlet is a test servlet that always prints a random number and
 * then makes the request Thread sleep for five minutes, thereby hanging
 * the Thread.  This is useful for testing Thread pools and servlet pools.
 *
 * @author Jason Brittain <brittainj@diamtech.com>
 */
public class SingleThreadedHang extends HttpServlet
    implements SingleThreadModel
{
    public void doGet(HttpServletRequest request,
		      HttpServletResponse response)
	throws ServletException, IOException
    {
	String response_content = 
	    "<HTML>\n<HEAD><TITLE>Locomotive - SingleThreadedHang" +
	    "</TITLE></HEAD>\n" +
	    "<BODY>\n\n<H1>SingleThreadedHang: Testing..</H1>\n" +
	    "This servlet prints a random number, and then sleeps for " +
	    "five minutes (hanging the request Thread in the process).  " +
	    "Here's the random number:\n<BR>\n<BR>\n" +
	    (int) (Math.random() * 10000) + "\n<BR>\n" +
	    "now sleeping for 5 minutes...\n";

	response_content = response_content + "<BR>\n<BR>\n</BODY>\n</HTML>";

	PrintWriter print_writer = response.getWriter();
	print_writer.print(response_content);
	print_writer.flush();

	// Close the writer.. this will signal the browser/client that
	// the connection is closed before this request Thread is done.
	print_writer.close();

	// Sleep after flushing the response and closing the connection.
	try
	{
	    Thread.sleep((long) (5 * 60 * 1000));
	}
	catch (Exception e)
	{
	    // Bummer.
	}
    }
    
    public void doPost(HttpServletRequest request,
		       HttpServletResponse response)
	throws ServletException, IOException
    {
	doGet(request, response);
    }
}
