/*
 * The contents of this file are subject to the Locomotive Public License 
 * (LPL), a derivative of the Mozilla Public License, version 1.0. You 
 * may not use this file except in compliance with the License; You may 
 * obtain a copy of the License at http://www.locomotive.org/license/.
 * 
 * Software distributed under the License is distributed on an "AS IS" basis, 
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License 
 * for the specific language governing rights and limitations under the 
 * License. 
 *
 * The initial developers of this code under the LPL is Leverage Information 
 * Systems.  Portions created by Leverage are Copyright (C) 1998 Leverage 
 * Information Systems. All Rights reserved.
 */

package org.locomotive.steam;

import org.locomotive.util.GrowableChar;
import java.util.*;


class AddNumbersExpr extends MixedExpr
{
    int MathOperationOn (int num1, int num2)
    {
	return (num1 + num2);
    }
    
    public void evaluate (Hashtable ht, GrowableChar growchar)
    {
	if (expr != null && expr.length > 1 && 
	    expr[0] != null && expr[1] != null)
	{
	    GrowableChar result = new GrowableChar(20);
	    int final_result;
	    
	    expr[0].evaluate (ht, result);
	    try {
		final_result = Integer.parseInt(result.toString());
	    }
	    catch (NumberFormatException nfe) {
		final_result = 0;
	    }
	    
	    for (int i=1; i < expr.length; i++)
	    {
		if (expr[i] != null)
		{
		    int next_result_value;
		    
		    result.clear();
		    expr[i].evaluate (ht, result);
		    try {
			next_result_value =
			    Integer.parseInt(result.toString());
			final_result = MathOperationOn (final_result,
							next_result_value);
		    }
		    catch (NumberFormatException nfe) {}
		}
	    }
	    
	    growchar.add (String.valueOf(final_result));
	}
    }
    
    public boolean notEmpty (Hashtable ht)
    {
	GrowableChar result = new GrowableChar(20);
	evaluate (ht, result);
	return (!result.toString().equals("0"));
    }
}

