/*
 * The contents of this file are subject to the Locomotive Public License 
 * (LPL), a derivative of the Mozilla Public License, version 1.0. You 
 * may not use this file except in compliance with the License; You may 
 * obtain a copy of the License at http://www.locomotive.org/license/.
 * 
 * Software distributed under the License is distributed on an "AS IS" basis, 
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License 
 * for the specific language governing rights and limitations under the 
 * License. 
 *
 * The initial developers of this code under the LPL is Leverage Information 
 * Systems.  Portions created by Leverage are Copyright (C) 1998 Leverage 
 * Information Systems. All Rights reserved.
 */

package org.locomotive.steam;

import org.locomotive.util.GrowableChar;
import java.util.*;


class EqualExpr extends MixedExpr
{
    public void evaluate (Hashtable ht, GrowableChar growchar)
    {
	if (notEmpty (ht))
	    growchar.add ("true");
    }
    
    public boolean notEmpty (Hashtable ht)
    {
	if (expr != null && expr.length > 1 && 
	    expr[0] != null && expr[1] != null)
	{
	    GrowableChar result = new GrowableChar(64);
	    
	    expr[0].evaluate (ht, result);
	    String result_str = result.toString(); 
	    
	    for (int i=1; i < expr.length; i++)
	    {
		if (expr[i] != null)
		{
		    result.clear();
		    expr[i].evaluate (ht, result);
		    if (! result_str.equals(result.toString()))
			return false;
		}
	    }
	    
	    return true;
	}
	else
	{
	    return false;
	}
    }
}
