/*
 * The contents of this file are subject to the Locomotive Public License 
 * (LPL), a derivative of the Mozilla Public License, version 1.0. You 
 * may not use this file except in compliance with the License; You may 
 * obtain a copy of the License at http://www.locomotive.org/license/.
 * 
 * Software distributed under the License is distributed on an "AS IS" basis, 
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License 
 * for the specific language governing rights and limitations under the 
 * License. 
 *
 * The initial developers of this code under the LPL is Leverage Information 
 * Systems.  Portions created by Leverage are Copyright (C) 1998 Leverage 
 * Information Systems. All Rights reserved.
 */

package org.locomotive.steam;

import org.locomotive.util.GrowableChar;
import java.util.*;


class IfExpr extends MixedExpr
{
    public void evaluate (Hashtable ht, GrowableChar growchar)
    {
//  	print ("IF: ");
	if (expr != null && expr.length > 1)
	{
	    if (expr[0] != null)
	    {
		if (expr[0].notEmpty(ht))
		{
		    if (expr[1] != null)
			expr[1].evaluate (ht, growchar);
		}
		else
		{
		    if (expr.length > 2 && expr[2] != null)
			expr[2].evaluate (ht, growchar);
		}
	    }
	}
    }
    
    public boolean notEmpty (Hashtable ht)
    {
//  	print ("NESTED IF: ");
	if (expr != null && expr.length > 1)
	{
	    if (expr[0] != null)
	    {
		if (expr[0].notEmpty(ht))
		{
		    if (expr[1] != null)
			return expr[1].notEmpty (ht);
		}
		else
		{
		    if (expr.length > 2 && expr[2] != null)
			return expr[2].notEmpty (ht);
		}
	    }
	}
	
	return false;
    }
}
