/*
 * The contents of this file are subject to the Locomotive Public License 
 * (LPL), a derivative of the Mozilla Public License, version 1.0. You 
 * may not use this file except in compliance with the License; You may 
 * obtain a copy of the License at http://www.locomotive.org/license/.
 * 
 * Software distributed under the License is distributed on an "AS IS" basis, 
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License 
 * for the specific language governing rights and limitations under the 
 * License. 
 *
 * The initial developers of this code under the LPL is Leverage Information 
 * Systems.  Portions created by Leverage are Copyright (C) 1998 Leverage 
 * Information Systems. All Rights reserved.
 */

package org.locomotive.steam;

import org.locomotive.util.GrowableChar;
import java.util.*;


class SetExpr extends MixedExpr
{
    public void evaluate (Hashtable ht, GrowableChar growchar)
    {
	if (expr != null && expr.length > 0 && expr[0] != null)
	{
	    GrowableChar var_name = new GrowableChar(20);
	    expr[0].evaluate(ht, var_name);
	    
	    if (expr.length < 2 || expr[1] == null)
	    {
		ht.remove (var_name.toString());
	    }
	    else
	    {
		GrowableChar set_value = new GrowableChar(64);
		expr[1].evaluate(ht, set_value);
		if (set_value.length() == 0)
		{
		    ht.remove (var_name.toString());
		}
		else
		{
		    ht.put (var_name.toString(), set_value.toString());
		}
//	        print ("SET: " + var_name.toString() + " TO: " + set_value.toString());
	    }
	}
    }
    
    /*
     * SET operations can return the value that they are set to, even though
     * their evaluate() does NOT write anything into growchar.  
     * Kinda like Lisp.
     */
    public boolean notEmpty (Hashtable ht)
    {
	return (expr != null && expr.length > 1 &&
		expr[1] != null && expr[1].notEmpty(ht));
    }
}

