/*
 * The contents of this file are subject to the Locomotive Public License 
 * (LPL), a derivative of the Mozilla Public License, version 1.0. You 
 * may not use this file except in compliance with the License; You may 
 * obtain a copy of the License at http://www.locomotive.org/license/.
 * 
 * Software distributed under the License is distributed on an "AS IS" basis, 
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License 
 * for the specific language governing rights and limitations under the 
 * License. 
 *
 * The initial developers of this code under the LPL is Leverage Information 
 * Systems.  Portions created by Leverage are Copyright (C) 1998 Leverage 
 * Information Systems. All Rights reserved.
 */

package org.locomotive.steam;

import org.locomotive.util.GrowableChar;
import java.util.*;

class VariableExpr extends MixedExpr
{
    protected String var_name;

    void printTree (String s)
    {
	System.out.println(s + "VAR: " + var_name);
	for (int i=0; i < expr.length; i++)
	{
	    expr[i].printTree (s + "  ");
	}
    }

    public VariableExpr (String var_name_str)
    {
	if (var_name_str == null)
	    var_name_str = "";

	var_name = var_name_str;

//	print ("NEW VAR: " + var_name);
    }
    
    public void evaluate (Hashtable ht, GrowableChar growchar)
    {
	Object var_value = ht.get (var_name);

	if (var_value != null && var_value.toString().length() > 0)
	    growchar.add (var_value.toString());
//  	print ("VAR: " + var_name + " --> " + var_value);
    }
    
    public boolean notEmpty (Hashtable ht)
    {
//  	print ("VAR: " + var_name + " --> " + (String) ht.get(var_name));
	return (var_name != null && ht.containsKey (var_name) &&
		(ht.get(var_name).toString()).length() > 0);
    }
}


