/*
 * The contents of this file are subject to the Locomotive Public License 
 * (LPL), a derivative of the Mozilla Public License, version 1.0. You 
 * may not use this file except in compliance with the License; You may 
 * obtain a copy of the License at http://www.locomotive.org/license/.
 * 
 * Software distributed under the License is distributed on an "AS IS" basis, 
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License 
 * for the specific language governing rights and limitations under the 
 * License. 
 *
 * The initial developers of this code under the LPL is Leverage Information 
 * Systems.  Portions created by Leverage are Copyright (C) 1998 Leverage 
 * Information Systems. All Rights reserved.
 */

package org.locomotive.util.data;

/**
 * Defines the compare function to allow arbitrary objects to be
 *  compared.
 */
public interface ComparisonKey {


   /**
    * Compare myself to another object
    * @param otherKey - the key to which this object is to be
    * compared
    * @return -1 - if this object is "less" than otherKey <BR>
    * 1 - if this object is "greater" than otherKey <BR>
    * 0 - if this object is equivalent to otherKey
    * @exception ComparisonKeyException <BR> 
    * if otherKey cannot be compared with this object
    */
    public int compare( ComparisonKey otherKey ) 
	throws ComparisonKeyException;


   /**
    * to assure a decent string representation of the comparisonKey
    */
   public String toString();

}


